unit Principal;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms, IniFiles,
  Dialogs, StdCtrls, Math, ColorGrd, ExtCtrls, ComCtrls, ActnList, CheckLst, Grids,
  ValEdit, Tipos, Simulador, ParamsCHAC, CHAC, CHAC4, Hexmap, Buttons;

type
  TfrmMapaCHAC = class(TForm)
    btnEjecutar: TButton;
    PanelMapa: TPanel;
    GroupBox1: TGroupBox;
    CeldaMuestra: TShape;
    Label2: TLabel;
    grbxTipoCelda: TGroupBox;
    rbtnCeldaNormal: TRadioButton;
    rbtnCeldaAgua: TRadioButton;
    rbtnCeldaBosque: TRadioButton;
    rbtnCeldaOBSTACULO: TRadioButton;
    grbxUnidadesBatalla: TGroupBox;
    grbxAltura: TGroupBox;
    trAltura: TTrackBar;
    lblAltura: TLabel;
    rbtnCIAOrigen: TRadioButton;
    rbtnCIADestino: TRadioButton;
    rbtnSituacionEnemigo: TRadioButton;
    rbtnLetalidad: TRadioButton;
    Label1: TLabel;
    Label3: TLabel;
    trLetalidad: TTrackBar;
    GroupBox2: TGroupBox;
    btnCargarMapa: TButton;
    btnGuardarMapa: TButton;
    btnTodoMapaIgual: TButton;
    btnLimpiarMapa: TButton;
    GroupBox3: TGroupBox;
    rbtn15x15: TRadioButton;
    rbtn45x45: TRadioButton;
    rbtn30x30: TRadioButton;
    rbtn10x10: TRadioButton;
    btnRedimensionarMapa: TButton;
    dlgAbrirMapa: TOpenDialog;
    dlgGuardarMapa: TSaveDialog;
    txtInfoCelda: TEdit;
    chkModoInfo: TCheckBox;
    btnSalir: TButton;
    btnVisibilidad: TButton;
    lblValAltura: TLabel;
    lblLetalidad: TLabel;
    btnVisibilidadZona: TButton;
    GroupBox5: TGroupBox;
    Panel2: TPanel;
    Label4: TLabel;
    sgSoluciones: TStringGrid;
    btnCargarSoluciones: TButton;
    dlgAbrirSoluciones: TOpenDialog;
    lbDetalleSoluciones: TListBox;
    btnMostrarSolucion: TButton;
    Label5: TLabel;
    chkMarcarZonaAtaque: TCheckBox;
    grbxDireccionEnemigo: TGroupBox;
    rbtn_dir_NO: TRadioButton;
    rbtn_dir_S: TRadioButton;
    rbtn_dir_SE: TRadioButton;
    rbtn_dir_SO: TRadioButton;
    rbtn_dir_NE: TRadioButton;
    rbtn_dir_N: TRadioButton;
    Label6: TLabel;
    btnActualizarValoresMapa: TButton;
    lblVersion: TLabel;
    txtInfoLAMBDASol: TEdit;
    MapaHEX: THexMap;
    HexaMuestra: THexMap;
    chkVerImagen: TCheckBox;
    txtInfoDimensiones: TEdit;
    btnEscogerMejoresSoluciones: TButton;
    edFicheroSoluciones: TEdit;
    edNumIT: TEdit;
    edNumH: TEdit;
    edRSel: TEdit;
    edrs: TEdit;
    btnImagenFondo: TButton;
    edImagenFondo: TEdit;
    dlgAbrirImagen: TOpenDialog;
    btnLimpiarSoluciones: TButton;
    GroupBox4: TGroupBox;
    btnMarcarVOEnemigos: TButton;
    btnMarcarObstaculosNat: TButton;
    btnLimpiarMarcasMapa: TButton;
    btnMostrarAreaCA: TButton;
    btnFPG: TButton;
    PanelDinamismo: TPanel;
    btnDInicio: TButton;
    btnDRetroceder: TButton;
    btnDAvanzar: TButton;
    btnDFin: TButton;
    btnCargarEventos: TBitBtn;
    dlgCargarEventos: TOpenDialog;
    edNumEvento: TEdit;
    edITEvento: TEdit;
    edXactEvento: TEdit;
    edYactEvento: TEdit;
    edXsigEvento: TEdit;
    edYsigEvento: TEdit;
    edAccionEvento: TEdit;
    lblAccionEvento: TLabel;
    procedure btnEjecutarClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure PanelMapaMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure rbtnCeldaNormalClick(Sender: TObject);
    procedure rbtnCeldaAguaClick(Sender: TObject);
    procedure rbtnCeldaBosqueClick(Sender: TObject);
    procedure rbtnCeldaOBSTACULOClick(Sender: TObject);
    procedure rbtnSituacionEnemigoClick(Sender: TObject);
    procedure rbtnLetalidadClick(Sender: TObject);
    procedure rbtnCIAOrigenClick(Sender: TObject);
    procedure rbtnCIADestinoClick(Sender: TObject);
    procedure btnLimpiarMapaClick(Sender: TObject);
    procedure btnTodoMapaIgualClick(Sender: TObject);
    procedure trAlturaChange(Sender: TObject);
    procedure PanelMapaMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure trLetalidadChange(Sender: TObject);
    procedure btnRedimensionarMapaClick(Sender: TObject);
    procedure btnCargarMapaClick(Sender: TObject);
    procedure btnGuardarMapaClick(Sender: TObject);
    procedure chkModoInfoClick(Sender: TObject);
    procedure btnSalirClick(Sender: TObject);
    procedure btnVisibilidadClick(Sender: TObject);
    procedure btnVisibilidadZonaClick(Sender: TObject);
    procedure btnCargarSolucionesClick(Sender: TObject);
    procedure sgSolucionesClick(Sender: TObject);
    procedure btnMostrarSolucionClick(Sender: TObject);
    procedure rbtn_dir_SClick(Sender: TObject);
    procedure rbtn_dir_NClick(Sender: TObject);
    procedure chkMarcarZonaAtaqueClick(Sender: TObject);
    procedure btnActualizarValoresMapaClick(Sender: TObject);
    procedure chkVerImagenClick(Sender: TObject);
    procedure btnEscogerMejoresSolucionesClick(Sender: TObject);
    procedure btnImagenFondoClick(Sender: TObject);
    procedure btnLimpiarSolucionesClick(Sender: TObject);
    procedure btnMarcarVOEnemigosClick(Sender: TObject);
    procedure btnMarcarObstaculosNatClick(Sender: TObject);
    procedure btnLimpiarMarcasMapaClick(Sender: TObject);
    procedure btnMostrarAreaCAClick(Sender: TObject);
    procedure btnFPGClick(Sender: TObject);
    procedure rbtn_dir_SEClick(Sender: TObject);
    procedure btnCargarEventosClick(Sender: TObject);
    procedure btnDInicioClick(Sender: TObject);
    procedure btnDRetrocederClick(Sender: TObject);
    procedure btnDAvanzarClick(Sender: TObject);
    procedure btnDFinClick(Sender: TObject);
{    procedure sgSolucionesSelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);}

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMapaCHAC: TfrmMapaCHAC;


implementation

//  uses CHAC;

type
   // fitness de solucin
   sol_fit = record
      fit_obj1: real;  // fitness del objetivo 1 (recursos)
      fit_obj2: real;  // fitness del objetivo 2 (salud)
   end;

   // frente de pareto con fitness
   frente_pareto_fit = record
      num_sols: integer;
      sols: array of sol_fit;
   end;

const

  ALT_VACIA: integer = -10000;

  // COLORES DE ALTURAS
(*
  // Normal
  COLNORM_AL_3: TColor = $007EADD7;
  COLNORM_AL_2: TColor = $005983AD;
  COLNORM_AL_1: TColor = $005983AD;
  COLNORM_AL0: TColor = $0039628C;
  COLNORM_AL1: TColor = $00194169;
  COLNORM_AL2: TColor = $00194169;
  COLNORM_AL3: TColor = $00052C51;

  // Agua
  COLAGUA_AL_3: TColor = $00FFCC99;
  COLAGUA_AL_2: TColor = $00F3CC00;
  COLAGUA_AL_1: TColor = $00F3CC00;
  COLAGUA_AL0: TColor = $00EF9900;
  COLAGUA_AL1: TColor = $00BC7200;
  COLAGUA_AL2: TColor = $00BC7200;
  COLAGUA_AL3: TColor = $00804A00;

  // Bosque
  COLBOSQ_AL_3: TColor = $009CCA82;
  COLBOSQ_AL_2: TColor = $0078B83C;
  COLBOSQ_AL_1: TColor = $0078B83C;
  COLBOSQ_AL0: TColor = $0051A600;
  COLBOSQ_AL1: TColor = $00367200;
  COLBOSQ_AL2: TColor = $00367200;
  COLBOSQ_AL3: TColor = $00264800;
*)

  // TONOS HIPSOMTRICOS

  // Normal
  COLNORM_AL3: TColor = $00B3E7FF;
  COLNORM_AL2: TColor = $007EADD7;
  COLNORM_AL1: TColor = $005983AD;
  COLNORM_AL0: TColor = $003B649A;
  COLNORM_AL_1: TColor = $0037607C;
  COLNORM_AL_2: TColor = $00194169;
  COLNORM_AL_3: TColor = $00052C51;

  // Agua
  COLAGUA_AL3: TColor = $00FFE5C2;
  COLAGUA_AL2: TColor = $00FFCC99;
  COLAGUA_AL1: TColor = $00F3BB00;
  COLAGUA_AL0: TColor = $00EF9900;
  COLAGUA_AL_1: TColor = $00CC7200;
  COLAGUA_AL_2: TColor = $00AC7200;
  COLAGUA_AL_3: TColor = $00804A00;

  // Bosque
  COLBOSQ_AL3: TColor = $00C2FFC2;
  COLBOSQ_AL2: TColor = $009CCA82;
  COLBOSQ_AL1: TColor = $0078B83C;
  COLBOSQ_AL0: TColor = $0053AA00;
  COLBOSQ_AL_1: TColor = $00468800;
  COLBOSQ_AL_2: TColor = $00367200;
  COLBOSQ_AL_3: TColor = $00264800;

  // Nivel de Dao
  COLDANIO_N1_25: TColor = $007996F6;
  COLDANIO_N25_50: TColor = $004F6CF2;
  COLDANIO_N50_75: TColor = $00393CFC;
  COLDANIO_N75_100: TColor = $00001AFF;

  // Obstculo
  COLOBSTACULO: TColor = $00000000;


// VARIABLES GLOBALES
var

  // Frente de Pareto Global (soluciones no dominadas de todos los ficheros que
  // haya con soluciones)
  FPG: frente_pareto_fit;

  // celdas a visualizar
  // @@@  Celdas: array of array of TShape;

  ColorTipoCelda: TColor;

  // dimensiones del mapa y las celdas
  NFILS_MAPA,NCOLS_MAPA: integer;
// @@@  TAMX_CELDA, TAMY_CELDA: integer;
  RADIO_CELDA: integer;

  // datos de las celdas para el algoritmo
  DatosCeldas: t_tablero; //array of array of t_celda;

  // Nombre del fichero del Mapa
  MapaActual: string;

  // Soluciones (del Frente de Pareto)
  Sols_FP: t_frente_pareto;

  relacion_rs: real;      // relacin entre rapidez y seguridad con la que se busc (lambda)

  soluciones_cargadas: boolean;
  mapa_cargado: boolean;
  eventos_cargados: boolean;

  sol_anterior: integer;
  num_sols_mostradas: integer;

  // variable de situacin de enemigo y enemigo conocido
  num_enemigos: byte;
  ENEMIGOS: t_lista_enemigos;

  // variables de eventos
  num_eventos: byte;
  EVENTOS: t_lista_eventos;
  ind_evento: integer;


  (* Variables para definir la zona de ataque de un enemigo *)

  // Plantilla con la zona de ataque
  zona_ataque_enemigo: array of array of t_celda;
  zona_ataque_enemigo_S: array of array of t_celda;

  // filas y columnas de la plantilla
  NFILS_PLANT_ZA,NCOLS_PLANT_ZA: integer;
  // posicin del enemigo dentro de la plantilla
  POS_PLANT_ENE_fil,POS_PLANT_ENE_col: integer;

{$R *.dfm}

// --------------------------------------------------------------

(*
   Procedimiento que lee los datos del fichero .INI y asigna los valores
   correspondientes a las variables ('constantes' de programa)
*)
procedure leer_ini();

var
  fich_ini: TIniFile;
  temp_cad: String;

begin

  // abrimos el fichero
  fich_ini:= TiniFile.Create(ExtractFileDir(ParamStr(0))+'\mss_CHAC.ini');

  // -------------------------
  // leemos datos de la Unidad
  // -------------------------
  CAP_ADQ_UNI:= fich_ini.ReadInteger('Unit','Adquisition_Capability',18);
  MAX_DIF_ALTURAS_UNI:= fich_ini.ReadInteger('Unit','Max_Height_Difference_Can_Go_Trough',2);

  // ----------------------------
  // leemos datos de los Enemigos
  // ----------------------------
  CAP_ADQ_ENE:= fich_ini.ReadInteger('Enemy','Adquisition_Capability',18);

  // -----------------------------------
  // Leemos los datos del Algoritmo CHAC
  // -----------------------------------

  // Parmetros del SCH
  ALPHA:= fich_ini.ReadInteger('CHAC_Algorithm','ALPHA',1);
  BETA:= fich_ini.ReadInteger('CHAC_Algorithm','BETA',2);
  temp_cad:= fich_ini.ReadString('CHAC_Algorithm','RHO','0.1');
  RHO:= strToFloat(temp_cad);
  temp_cad:= fich_ini.ReadString('CHAC_Algorithm','q0','0.4');
  q0:= strToFloat(temp_cad);
  temp_cad:= fich_ini.ReadString('CHAC_Algorithm','PHI','0.1');
  PHI:= strToFloat(temp_cad);

  // Constantes de Ponderacin de las Heursticas
  // N1 (Camino ms Rpido)
  temp_cad:= fich_ini.ReadString('CHAC_Algorithm','WEIGHT_N1_RESOURCES','0.1');
  KN1_REC:= strToFloat(temp_cad);
  temp_cad:= fich_ini.ReadString('CHAC_Algorithm','WEIGHT_N1_VISIB','0.05');
  KN1_VO:= strToFloat(temp_cad);
  temp_cad:= fich_ini.ReadString('CHAC_Algorithm','WEIGHT_N1_TARGET_DIST','0.85');
  KN1_DIS:= strToFloat(temp_cad);

  // N2 (Camino ms Seguro)
  temp_cad:= fich_ini.ReadString('CHAC_Algorithm','WEIGHT_N1_HEALTH','0.1');
  KN2_DAN:= strToFloat(temp_cad);
  temp_cad:= fich_ini.ReadString('CHAC_Algorithm','WEIGHT_N2_VISIB','0.85');
  KN2_VO:= strToFloat(temp_cad);
  temp_cad:= fich_ini.ReadString('CHAC_Algorithm','WEIGHT_N2_TARGET_DIST','0.05');
  KN2_DIS:= strToFloat(temp_cad);

  // Constantes de Ponderacin de la Funcin de Evaluacin
  temp_cad:= fich_ini.ReadString('CHAC_Algorithm','WEIGHT_EV1_HZ','0.5');
  KEV1_ZVO:= strToFloat(temp_cad);
  temp_cad:= fich_ini.ReadString('CHAC_Algorithm','WEIGHT_EV2_HZ','10.0');
  KEV2_ZVO:= strToFloat(temp_cad);

  // cerramos el fichero
  fich_ini.Free;

end;

// --------------------------------------------------------------

(*
   Procedimiento que deja todas las celdas con sus valores por defecto
   es decir, deja el mapa 'limpio'
*)
procedure LimpiarMapa();
var
   i,j: integer;

begin

  // limpiamos los datos liberando y reservando de nuevo
  Finalize(DatosCeldas);
  SetLength(DatosCeldas,NFILS_MAPA,NCOLS_MAPA);

  // limpiamos el mapa (lo destruimos y lo volvemos a crear)
// @@@  frmMapaCHAC.MapaHEX.destroy;
// @@@  frmMapaCHAC.MapaHEX.Create(frmMapaCHAC.PanelMapa);

  // dimensiones
  frmMapaCHAC.MapaHEX.HexColumns:= 1;
  frmMapaCHAC.MapaHEX.HexColumns:= NCOLS_MAPA;
  frmMapaCHAC.MapaHEX.HexRows:= NFILS_MAPA;
  frmMapaCHAC.MapaHEX.HexRadius:= RADIO_CELDA;

  // apariencia
  frmMapaCHAC.MapaHEX.Hex3d:= FALSE;
  frmMapaCHAC.MapaHEX.HexColor:= clWhite;
  frmMapaCHAC.MapaHEX.BackColor:= clBtnFace;
  frmMapaCHAC.MapaHEX.LineColor:= clGray;

  // creamos las celdas del mapa
  for i:= 0 to (NFILS_MAPA-1) do begin
     for j:= 0 to (NCOLS_MAPA-1) do begin
        // inicializamos la altura para indicar celda vacia
        DatosCeldas[i,j].altura:= ALT_VACIA;
     end;
  end;

  frmMapaCHAC.txtInfoCelda.Text:='';
  frmMapaCHAC.txtInfoLAMBDASol.Text:='';

  // se permite dibujar
  frmMapaCHAC.chkModoInfo.Checked:=FALSE;


  // SE LIMPIAN LOS DATOS DE LAS SOLUCIONES

  // limpiamos los cuadros con las soluciones
  frmMapaCHAC.sgSoluciones.RowCount:= 1;
  frmMapaCHAC.lbDetalleSoluciones.Items.Clear;

  // se limpian las soluciones guardadas
  Finalize(Sols_FP);

  // se inicializa la solucin anterior (no hay)
  sol_anterior:= -1;
  num_sols_mostradas:= 0;

end;

// --------------------------------------------------------------

(*
   Procedimiento que crea el mapa dentro del panel elegido y con el
   tamao deseado (nmero de celdas por fila y columna)
   Recibe como parmetros:
      - PnMapa -> panel dentro del que se incluirn las celdas
      - fils_ant -> nmero de filas que tena el mapa anteriormente
      - cols_ant -> nmero de columnas que tena el mapa anteriormente
*)
procedure CrearMapa(var PnMapa: TPanel; fils_ant, cols_ant: integer);
var
   i,j: integer;

begin

  // lo destruimos y lo volvemos a crear
// @@@ frmMapaCHAC.MapaHEX.destroy;
// @@@ frmMapaCHAC.MapaHEX.Create(PnMapa);

  // dimensiones
  frmMapaCHAC.MapaHEX.HexColumns:= NCOLS_MAPA;
  frmMapaCHAC.MapaHEX.HexRows:= NFILS_MAPA;
  frmMapaCHAC.MapaHEX.HexRadius:= RADIO_CELDA;

  // apariencia
  frmMapaCHAC.MapaHEX.Hex3d:= FALSE;
  frmMapaCHAC.MapaHEX.HexColor:= clWhite;
  frmMapaCHAC.MapaHEX.BackColor:= clBtnFace;
  frmMapaCHAC.MapaHEX.LineColor:= clGray;


  // Redimensionamos el array de Celdas

  Finalize(DatosCeldas);
  // reservamos memoria para el nuevo tamao
  SetLength(DatosCeldas,NFILS_MAPA,NCOLS_MAPA);

  // CREAMOS EL NUEVO MAPA

  // creamos las celdas del mapa
  for i:= 0 to (NFILS_MAPA-1) do begin
     for j:= 0 to (NCOLS_MAPA-1) do begin
// @@@
// @@@
// @@@
        // inicializamos la altura para indicar celda vacia
        DatosCeldas[i,j].altura:= ALT_VACIA;
     end;
  end;

  // LIMPIAMOS LOS DATOS DE LAS SOLUCIONES

  // limpiamos los cuadros con las soluciones
  frmMapaCHAC.sgSoluciones.RowCount:= 1;
  frmMapaCHAC.lbDetalleSoluciones.Items.Clear;

  // se limpian las soluciones guardadas
  Finalize(Sols_FP);

  // se inicializa la solucin anterior (no hay)
  sol_anterior:= -1;
  num_sols_mostradas:= 0;
  
  // se limpia la informacin de las celdas
  frmMapaCHAC.txtInfoCelda.Text:='';
  frmMapaCHAC.txtInfoLAMBDASol.Text:='';

  // se permite dibujar
  frmMapaCHAC.chkModoInfo.Checked:=FALSE;

end;

// --------------------------------------------------------------

(*
   Procedimiento que dibuja la celda elegida, asignando un color, forma y
   estilo en base al tipo de celda y altura.
   Recibe como parmetros:
      - celda_dib -> celda a dibujar
*)
procedure DibujarCelda(celda_dib: t_celda);
var
   altura: integer;

   color_cel: TColor;
   grosor_borde: integer;
   color_borde: integer;

   pos: TPoint;

begin

// @@@
// @@@  Variables cambiadas
// @@@

  // si la celda tiene altura ALT_VACIA (-10000) es que es vaca y no se dibuja nada
  if (celda_dib.altura=ALT_VACIA) then exit;

  // valores por defecto
  color_cel:= clWhite;
  color_borde:= clGray;
  grosor_borde:= 1;

  // color de la celda si es un impacto de arma
  if (celda_dib.tipo_esp=IMPARMA) then begin

     if (celda_dib.danio_arma > 0) and (celda_dib.danio_arma <= DANIO_NIVEL_1) then
        color_cel:= COLDANIO_N1_25   // 1-25 de dao
     else if (celda_dib.danio_arma > DANIO_NIVEL_1) and (celda_dib.danio_arma <= DANIO_NIVEL_2) then
        color_cel:= COLDANIO_N25_50   // 26-50 de dao
     else if (celda_dib.danio_arma > DANIO_NIVEL_2) and (celda_dib.danio_arma <= DANIO_NIVEL_3) then
        color_cel:= COLDANIO_N50_75   // 51-75 de dao
     else if (celda_dib.danio_arma > DANIO_NIVEL_3) and (celda_dib.danio_arma <= DANIO_NIVEL_4) then
        color_cel:= COLDANIO_N75_100;  // 76-100 de dao

     // Dibujamos el Hexgono con los parmetros elegidos
     pos.x := celda_dib.x+1;
     pos.y := celda_dib.y+1;

     // si est la imagen de fondo no se sobreescribe
     if (frmMapaCHAC.chkVerImagen.Checked=TRUE) then
        // no se refresca al dibujar
        frmMapaCHAC.MapaHEX.PintaBordeHex(pos,color_borde,grosor_borde,color_borde,grosor_borde,
                                          color_borde,grosor_borde,color_borde,grosor_borde,
                                          color_borde,grosor_borde,color_borde,grosor_borde,FALSE)
     else
        // no se refresca al dibujar
        frmMapaCHAC.MapaHEX.Pinta1Hex(color_cel,bsSolid,pos,psSolid,color_borde,grosor_borde,TRUE,FALSE);

     exit;
  end;

  // color de la celda si es un obstculo
  if (celda_dib.tipo=OBST) then begin
     color_cel:= COLOBSTACULO;

     // Dibujamos el Hexgono con los parmetros elegidos
     pos.x := celda_dib.x+1;
     pos.y := celda_dib.y+1;

     // si est la imagen de fondo no se sobreescribe
     if (frmMapaCHAC.chkVerImagen.Checked=TRUE) then
        // no se refresca al dibujar
        frmMapaCHAC.MapaHEX.Pinta1Hex(color_cel,bsSolid,pos,psSolid,color_borde,grosor_borde,FALSE,FALSE)
     else
        // no se refresca al dibujar
        frmMapaCHAC.MapaHEX.Pinta1Hex(color_cel,bsSolid,pos,psSolid,color_borde,grosor_borde,TRUE,FALSE);

     exit;
  end;

  // color de la celda es otro caso (en base a la altura)
  altura:= (celda_dib.altura * -1);

  if (celda_dib.tipo=NORM) then begin
     case (altura) of
            3: color_cel:= COLNORM_AL3;
            2: color_cel:= COLNORM_AL2;
            1: color_cel:= COLNORM_AL1;
            0: color_cel:= COLNORM_AL0;
           -1: color_cel:= COLNORM_AL_1;
           -2: color_cel:= COLNORM_AL_2;
           -3: color_cel:= COLNORM_AL_3;
     end;
  end
  else if (celda_dib.tipo=AGUA) then begin
     case (altura) of
            3: color_cel:= COLAGUA_AL3;
            2: color_cel:= COLAGUA_AL2;
            1: color_cel:= COLAGUA_AL1;
            0: color_cel:= COLAGUA_AL0;
           -1: color_cel:= COLAGUA_AL_1;
           -2: color_cel:= COLAGUA_AL_2;
           -3: color_cel:= COLAGUA_AL_3;
     end;
  end
  else if (celda_dib.tipo=BOSQ) then begin
     case (altura) of
            3: color_cel:= COLBOSQ_AL3;
            2: color_cel:= COLBOSQ_AL2;
            1: color_cel:= COLBOSQ_AL1;
            0: color_cel:= COLBOSQ_AL0;
           -1: color_cel:= COLBOSQ_AL_1;
           -2: color_cel:= COLBOSQ_AL_2;
           -3: color_cel:= COLBOSQ_AL_3;
     end;
  end;

  // estilo de la celda si es de un tipo especial
  if (celda_dib.tipo_esp=PORIGEN) then begin
     grosor_borde:= 4; //(2*RADIO_CELDA) div 10;
     color_borde:= clBlack;
     // @@@ etiqueta O ???
  end
  else if (celda_dib.tipo_esp=PDESTINO) then begin
     grosor_borde:= 4; //(2*RADIO_CELDA) div 10;
     color_borde:= clYellow;
     // @@@ etiqueta D ???
  end
  else if (celda_dib.tipo_esp=ENEMIGO) then begin
     grosor_borde:= 4; //(2*RADIO_CELDA) div 10;
     color_borde:= clRed;
     // @@@ etiqueta E ???
  end;

  // Dibujamos el Hexgono con los parmetros elegidos
  pos.x := celda_dib.x+1;
  pos.y := celda_dib.y+1;

  // si est la imagen de fondo no se sobreescribe
  if (frmMapaCHAC.chkVerImagen.Checked=TRUE) then
     // no se refresca al dibujar
     frmMapaCHAC.MapaHEX.Pinta1Hex(color_cel,bsSolid,pos,psSolid,color_borde,grosor_borde,FALSE,FALSE)
  else
     // no se refresca al dibujar
     frmMapaCHAC.MapaHEX.Pinta1Hex(color_cel,bsSolid,pos,psSolid,color_borde,grosor_borde,TRUE,FALSE);


end;

// --------------------------------------------------------------

(*
   Procedimiento que lee el fichero con los datos del mapa, rellena
   las celdas con esos valores y las muestra en pantalla
   Recibe como parmetros:
      - nombre_fichero -> fichero con los datos
*)
procedure CargarMapa(nombre_fichero: string);
var
   fich_mapa: File of t_celda;
   celda_aux: t_celda;
   i,j: integer;

   fils_ant,cols_ant: integer;

   cad_aux: string;

begin

  // se abre el fichero para lectura
  AssignFile(fich_mapa, nombre_fichero);
  Reset(fich_mapa);

  // se lee la primera celda (informacin del tamao del mapa)
  if not Eof(fich_mapa) then
     Read(fich_mapa,celda_aux);

  // Creamos el Mapa de Celdas y las nuevas matrices si es necesario
  if (celda_aux.x<>NCOLS_MAPA) or (celda_aux.y<>NFILS_MAPA) then begin

     fils_ant:= NFILS_MAPA;
     cols_ant:= NCOLS_MAPA;
     NFILS_MAPA:= celda_aux.y;
     NCOLS_MAPA:= celda_aux.x;

     // elegimos el radiobutton de la dimensin del mapa
     // y los tamaos de las celdas en funcin del nmero de ellas
     if (NFILS_MAPA>=10) and (NFILS_MAPA<=14) then begin
        frmMapaCHAC.rbtn10x10.Checked:= TRUE;
        RADIO_CELDA:= 34;
     end
     else if (NFILS_MAPA>=15) and (NFILS_MAPA<=20) then begin
        frmMapaCHAC.rbtn15x15.Checked:= TRUE;
        RADIO_CELDA:= 22;
     end
     else if (NFILS_MAPA>=30) and (NFILS_MAPA<=35) then begin
        frmMapaCHAC.rbtn30x30.Checked:= TRUE;
        RADIO_CELDA:= 12;
     end
     else if (NFILS_MAPA>=45) and (NFILS_MAPA<=50) then begin
        frmMapaCHAC.rbtn45x45.Checked:= TRUE;
        RADIO_CELDA:= 8;
     end;

     // @@@ Informamos de las dimensiones del mapa
     // Informamos de las dimensiones del mapa
     frmMapaCHAC.txtInfoDimensiones.Text:= ' ' + IntToStr(NFILS_MAPA) + ' Rows x '
                                               + IntToStr(NCOLS_MAPA) + ' Cols | Rad = '
                                               + IntToStr(RADIO_CELDA);

     // Creamos el Mapa con los valores completados anteriormente
     CrearMapa(frmMapaCHAC.PanelMapa,fils_ant,cols_ant);

  end
  else
     // Si no hay que crearlo (el mismo tamao), solo se limpia
     LimpiarMapa();


  // Leemos el resto del mapa
  i:= 0;
  j:= 0;
  while not Eof(fich_mapa) do
  begin
     Read(fich_mapa, DatosCeldas[i,j]);

     DibujarCelda(DatosCeldas[i,j]);

     // pasamos al siguiente elemento
     j:= j+1;
     if (j=NCOLS_MAPA) then begin
        j:= 0;
        i:= i+1;
        if (i=NFILS_MAPA) then i:= 0;
     end;
  end;

  // @@@ se redibujan las celdas de origen, destino y enemigos para
  // @@@ que se vea bien el borde
  for i:= 0 to (NFILS_MAPA-1) do begin
     for j:= 0 to (NCOLS_MAPA-1) do begin

        if (DatosCeldas[i,j].tipo_esp=ENEMIGO) or
           (DatosCeldas[i,j].tipo_esp=PORIGEN) or
           (DatosCeldas[i,j].tipo_esp=PDESTINO) then begin
           DibujarCelda(DatosCeldas[i,j]);
        end;

     end;
  end;

  // una vez dibujado todo, se hace el refresco para dibujar el mapa sin parpadeo
  frmMapaCHAC.MapaHEX.Refrescar;


  frmMapaCHAC.chkModoInfo.Checked:= TRUE;
  frmMapaCHAC.PanelMapa.Cursor:= crHelp;

  // guardamos el nombre del fichero
  MapaActual:= nombre_fichero;

  // Ponemos el nombre del mapa en el ttulo del form
  cad_aux:= frmMapaCHAC.Caption;
  delete(cad_aux,17,200);
  frmMapaCHAC.Caption:= cad_aux + ' - [' + MapaActual + ']';


  // cerramos el fichero
  CloseFile(fich_mapa);

end;

// --------------------------------------------------------------

(*
   Procedimiento que lee el fichero con la plantilla de zona de ataque del enemigo
   y la guarda en una matriz.
   Recibe como parmetros:
      - nombre_fichero -> fichero de tipo mapa con la plantilla
*)
procedure CargarZonaAtaqueEnemigo(nombre_fichero: string);
var
   fich_plantilla: File of t_celda;
   celda_aux: t_celda;
   i,j: integer;

begin

  // se abre el fichero para lectura
  AssignFile(fich_plantilla, nombre_fichero);
  Reset(fich_plantilla);

  // se lee la primera celda (informacin del tamao de la plantilla)
  if not Eof(fich_plantilla) then
     Read(fich_plantilla,celda_aux);

  NFILS_PLANT_ZA:= celda_aux.y;
  NCOLS_PLANT_ZA:= celda_aux.x;

  // reservamos memoria para la nueva plantilla
  Finalize(zona_ataque_enemigo);
  SetLength(zona_ataque_enemigo,NFILS_PLANT_ZA,NCOLS_PLANT_ZA);

  POS_PLANT_ENE_fil:= -1;
  POS_PLANT_ENE_col:= -1;

  // Leemos la plantilla
  i:= 0;
  j:= 0;
  while not Eof(fich_plantilla) do
  begin
     Read(fich_plantilla, zona_ataque_enemigo[i,j]);

     // si est el enemigo, se apunta su posicin en la plantilla
     if (zona_ataque_enemigo[i,j].tipo_esp = ENEMIGO) then begin
        POS_PLANT_ENE_fil:= i;
        POS_PLANT_ENE_col:= j;
     end;

     // pasamos al siguiente elemento
     // si se han terminado las columnas, se pasa a la siguiente fila
     j:= j+1;
     if (j=NCOLS_PLANT_ZA) then begin
        j:= 0;
        i:= i+1;
        if (i=NFILS_PLANT_ZA) then i:= 0;
     end;
  end;

  // cerramos el fichero
  CloseFile(fich_plantilla);

  // mensaje de plantilla correcta o incorrecta
  if (POS_PLANT_ENE_fil <> -1) and (POS_PLANT_ENE_fil <> -1) then begin

     ShowMessage('Template Loaded Correctly');

     // reservamos memoria para la nueva plantilla
     Finalize(zona_ataque_enemigo_S);
     SetLength(zona_ataque_enemigo_S,NFILS_PLANT_ZA,NCOLS_PLANT_ZA);

     // copiamos la plantilla al frente SUR
     for i:=0 to (NFILS_PLANT_ZA-1) do
        for j:=0 to (NCOLS_PLANT_ZA-1) do
           zona_ataque_enemigo_S[i,j]:= zona_ataque_enemigo[i,j];

  end
  else begin
     ShowMessage('Bad Template. No enemy position is defined');
     frmMapaCHAC.chkMarcarZonaAtaque.Checked:= FALSE;
     frmMapaCHAC.grbxDireccionEnemigo.Enabled:= FALSE;
  end;

end;

// --------------------------------------------------------------

(*
   Procedimiento que lee el fichero con los datos de las soluciones y rellena
   el String Grid con ellos.
   Recibe como parmetros:
      - nombre_fichero -> fichero con las soluciones
*)
procedure CargarSoluciones(nombre_fichero: string);
var
   fich_sols: File of t_celda;
   celda_aux: t_celda;
   i,j: integer;

begin

  // se abre el fichero para lectura
  AssignFile(fich_sols, nombre_fichero);
  Reset(fich_sols);

  // se lee la primera celda (nmero de soluciones)
  if not Eof(fich_sols) then
     Read(fich_sols,celda_aux);

  // reservamos memoria para las soluciones (liberamos antes para asegurar)
  Finalize(Sols_FP);
  SetLength(Sols_FP.soluciones_FP,celda_aux.x);
  Sols_FP.num_sols_FP:= celda_aux.x;   // nmero de soluciones

  if (celda_aux.danio_arma >= 0.1) and (celda_aux.danio_arma <= 0.9) then
     relacion_rs:= celda_aux.danio_arma  // relacin rapidez/seguridad con la que se busc
  else
     relacion_rs:= 0;   // no se guard el valor correcto (soluciones de versiones anteriores)

  // se lee la primera de la solucin (nmero de nodos y fitness)
  if not Eof(fich_sols) then
     Read(fich_sols,celda_aux);

  // reservamos memoria para el camino (conjunto de nodos)
  SetLength(Sols_FP.soluciones_FP[0].camino,celda_aux.x);

  Sols_FP.soluciones_FP[0].fit_obj1:= celda_aux.recursos_0;
  Sols_FP.soluciones_FP[0].fit_obj2:= celda_aux.danio_0;

  // Leemos cada una de las soluciones
  i:= 0;
  j:= 0;
  while not Eof(fich_sols) do begin

     // si hemos leido todos los nodos, leemos la siguiente remesa
     if (j=celda_aux.x) then begin
        Read(fich_sols, celda_aux);

        j:= 0;
        i:= i+1;

        // guardamos los fitness
        Sols_FP.soluciones_FP[i].fit_obj1:= celda_aux.recursos_0;
        Sols_FP.soluciones_FP[i].fit_obj2:= celda_aux.danio_0;

        // reservamos memoria para el camino (conjunto de nodos)
        SetLength(Sols_FP.soluciones_FP[i].camino,celda_aux.x);
     end
     else begin
        Read(fich_sols, Sols_FP.soluciones_FP[i].camino[j]);
        j:= j+1;
     end;

  end;

  // cerramos el fichero
  CloseFile(fich_sols);

end;

// --------------------------------------------------------------

(*
   Procedimiento que lee el fichero con los datos de eventos sobre el mapa.
   Recibe como parmetros:
      - nombre_fichero -> fichero con los eventos (tipo ini)
*)
procedure CargarEventos(nombre_fichero: string);
var
  fich_eve: TIniFile;
  temp_cad: String;

  cont_eventos: integer;
  i: integer;
  temp: integer;

begin

  // abrimos el fichero
  fich_eve:= TiniFile.Create(nombre_fichero);

  // -------------------------------
  // leemos los datos de los eventos
  // -------------------------------

  cont_eventos:= fich_eve.ReadInteger('DATOS_EVENTOS','Numero_eventos',0);
  num_eventos:= 0;
  Setlength(EVENTOS,num_eventos);

  // solo para los que tengan una iteracin asignada
  for i:=0 to (cont_eventos-1) do begin

      temp:= fich_eve.ReadInteger(('EVENTO_'+IntToStr(i+1)),'Iteracion',-1);

      // si la iteracin es '-1', se pasa del evento
      if (temp <= -1) then continue;

      // aadimos un evento
      num_eventos:= num_eventos+1;
      Setlength(EVENTOS,num_eventos);

      // guardamos los datos del evento
      // iteracin
      EVENTOS[num_eventos-1].it:= temp;
      // tipo
      temp_cad:= fich_eve.ReadString(('EVENTO_'+IntToStr(i+1)),'Accion', 'XXX');
      if (temp_cad='IE') then EVENTOS[num_eventos-1].tipo:= INS_ENE
      else if (temp_cad='DE') then EVENTOS[num_eventos-1].tipo:= DEL_ENE
      else if (temp_cad='ME') then EVENTOS[num_eventos-1].tipo:= MOV_ENE
      else if (temp_cad='MD') then EVENTOS[num_eventos-1].tipo:= MOV_DES
      else EVENTOS[num_eventos-1].it:= -1; // se asigna como iteracin el -1 para seguridad
      // coordenadas actuales del objeto
      EVENTOS[num_eventos-1].x_act:= fich_eve.ReadInteger(('EVENTO_'+IntToStr(i+1)),'Xactual', -1);
      EVENTOS[num_eventos-1].y_act:= fich_eve.ReadInteger(('EVENTO_'+IntToStr(i+1)),'Yactual', -1);
      // coordenadas siguientes del objeto
      EVENTOS[num_eventos-1].x_sig:= fich_eve.ReadInteger(('EVENTO_'+IntToStr(i+1)),'Xsiguiente', -1);
      EVENTOS[num_eventos-1].y_sig:= fich_eve.ReadInteger(('EVENTO_'+IntToStr(i+1)),'Ysiguiente', -1);

  end;

  // cerramos el fichero
  fich_eve.Free;

end;

// --------------------------------------------------------------

procedure BuscarMinimos(nfichero_sols: string; rs: string; nfichero_mins: string);
var

   fich_sols: File of t_celda;
   fich_mins: TextFile;

   celda_aux,celda_auxnodo: t_celda;
   j: integer;

   min_s, min_r: real;

begin

  // se abre el fichero para lectura
  AssignFile(fich_sols, nfichero_sols);
  Reset(fich_sols);

  // se lee la primera celda (nmero de soluciones)
  if not Eof(fich_sols) then
     Read(fich_sols,celda_aux);

  if (celda_aux.danio_arma >= 0.1) and (celda_aux.danio_arma <= 0.9) then
     relacion_rs:= celda_aux.danio_arma  // relacin rapidez/seguridad con la que se busc
  else
     relacion_rs:= 0;   // no se guard el valor correcto (soluciones de versiones anteriores)

  // se lee la primera de la solucin (nmero de nodos y fitness)
  if not Eof(fich_sols) then
     Read(fich_sols,celda_aux);

  // minimos hasta el momento
  min_r:= celda_aux.recursos_0;
  min_s:= celda_aux.danio_0;

  // Leemos cada una de las soluciones
  j:= 0;
  while not Eof(fich_sols) do begin

     // si hemos leido todos los nodos, leemos la siguiente remesa
     if (j=celda_aux.x) then begin
        Read(fich_sols, celda_aux);

        j:= 0;

        // mnimos recursos
        if rs='+r' then begin

           if min_r > celda_aux.recursos_0 then begin
              // guardamos los fitness como mnimos
              min_r:= celda_aux.recursos_0;
              min_s:= celda_aux.danio_0;
           end;

        end
        // mnima salud
        else begin

           if min_s > celda_aux.danio_0 then begin
              // guardamos los fitness como mnimos
              min_r:= celda_aux.recursos_0;
              min_s:= celda_aux.danio_0;
           end;

        end

     end
     else begin
        Read(fich_sols, celda_auxnodo);
        j:= j+1;
     end;

  end;

  // cerramos el fichero
  CloseFile(fich_sols);

  // escribimos el mnimo en el fichero elegido
  AssignFile(fich_mins, nfichero_mins);
  Append(fich_mins);

  Writeln(fich_mins, FloatToStr(min_r) + #9 + FloatToStr(min_s));
  Flush(fich_mins);
  CloseFile(fich_mins);

end;

// --------------------------------------------------------------

function comprobarsolucionFP(fs: real; fr: real):boolean;

var
  i: integer;
  dominada: boolean;

begin

   if (FPG.num_sols = 0) then begin
      Result:= TRUE;
      exit;
   end;

   dominada:= FALSE;

   // recorremos el Frente de Pareto Comprobando si la solucin es dominada por alguna
   // (una solucin domina a otra si es mejor en ambos objetivos o es igual en uno y
   //  mejor en otro)
   // en este caso es mejor el de menor valor
   for i:=0 to (FPG.num_sols-1) do begin

       if ((fr >= FPG.sols[i].fit_obj1) and
           (fs > FPG.sols[i].fit_obj2)) or
          ((fr > FPG.sols[i].fit_obj1) and
           (fs >= FPG.sols[i].fit_obj2)) then begin
           // es dominada por alguna otra solucin
           dominada:= TRUE;
           break;
       end
       else if (fr = FPG.sols[i].fit_obj1) and
               (fs = FPG.sols[i].fit_obj2) then begin
           // es igual que alguna otra solucin (la consideramos dominada para
           // no repetirla)
           dominada:= TRUE;
           break;
       end;

   end;

   Result:= (not dominada);

end;

//------------------------------------------------------------------------------

procedure AniadirSolsFPG(nfichero_sols: string; todas: boolean);
var

   fich_sols: File of t_celda;

   celda_aux,celda_auxnodo: t_celda;
   j: integer;

   salud, recursos: real;

begin

  // se abre el fichero para lectura
  AssignFile(fich_sols, nfichero_sols);
  Reset(fich_sols);

  // se lee la primera celda (nmero de soluciones)
  if not Eof(fich_sols) then
     Read(fich_sols,celda_aux);

  // se lee la primera de la solucin (nmero de nodos y fitness)
  if not Eof(fich_sols) then
     Read(fich_sols,celda_aux);

  // leemos los fitness de los objetivos
  recursos:= celda_aux.recursos_0;
  salud:= celda_aux.danio_0;

  // aadimos la solucin al Frente de Pareto si no est dominada
  if (comprobarsolucionFP(salud,recursos)=TRUE) then begin
     Setlength(FPG.sols,FPG.num_sols+1);
     FPG.sols[FPG.num_sols].fit_obj1:= recursos;
     FPG.sols[FPG.num_sols].fit_obj2:= salud;
     FPG.num_sols:= FPG.num_sols+1;
  end;

  // Leemos cada una de las soluciones
  j:= 0;
  while not Eof(fich_sols) do begin

     // si hemos leido todos los nodos, leemos la siguiente remesa
     if (j=celda_aux.x) then begin
        Read(fich_sols, celda_aux);

        j:= 0;

        // leemos los fitness de los objetivos
        recursos:= celda_aux.recursos_0;
        salud:= celda_aux.danio_0;

        // aadimos la solucin al Frente de Pareto si no est dominada
        if (comprobarsolucionFP(salud,recursos)=TRUE) then begin
          Setlength(FPG.sols,FPG.num_sols+1);
          FPG.sols[FPG.num_sols].fit_obj1:= recursos;
          FPG.sols[FPG.num_sols].fit_obj2:= salud;
          FPG.num_sols:= FPG.num_sols+1;
        end;

     end
     else begin
        Read(fich_sols, celda_auxnodo);
        j:= j+1;
     end;

  end;

  // cerramos el fichero
  CloseFile(fich_sols);

end;

// --------------------------------------------------------------

(*
   Procedimiento que muestra las soluciones leidas de fichero en la lista
*)
procedure MostrarListaSoluciones();

var
   i: integer;
   vl: real;

begin

   // si hay LAMBDA guardado, se muestra la relacin con la que se busc
   if (relacion_rs <> 0) then begin

      vl:= (1.0-relacion_rs) * 100;

      frmMapaCHAC.txtInfoLAMBDASol.text:= ' ' + FloatToStrF((100.0-vl),ffGeneral,2,0) +
      '% speed  -  ' + FloatToStrF(vl,ffGeneral,2,0) + '% safety';
   end
   else
      frmMapaCHAC.txtInfoLAMBDASol.text:= '';


   // creamos tantas filas como soluciones haya
   frmMapaCHAC.sgSoluciones.RowCount:= Sols_FP.num_sols_FP+1;
   frmMapaCHAC.sgSoluciones.FixedRows:= 1;

   // rellenamos los strings con las soluciones
   for i:=0 to (Sols_FP.num_sols_FP-1) do begin
      frmMapaCHAC.sgSoluciones.Cells[0,i+1]:= IntToStr(i);
      frmMapaCHAC.sgSoluciones.Cells[1,i+1]:= FloatToStrF(Sols_FP.soluciones_FP[i].fit_obj1,ffGeneral,7,20);
      frmMapaCHAC.sgSoluciones.Cells[2,i+1]:= FloatToStrF(Sols_FP.soluciones_FP[i].fit_obj2,ffGeneral,7,20);
   end;

   // nos situamos en la primera solucin
   frmMapaCHAC.sgSoluciones.Row:= 1;

end;


// --------------------------------------------------------------

(*
   Procedimiento que limpia las marcas que se hayan dibujado sobre el mapa
*)
procedure LimpiarMarcasMapa();

var
   i,j: integer;

begin

     // si se est mostrando la imagen de fondo, se limpia
     if (frmMapaCHAC.chkVerImagen.Checked=TRUE) then begin
       frmMapaCHAC.chkVerImagen.Checked:= FALSE;
       exit;
     end;

     // @@@ se redibujan todas las celdas
     for i:= 0 to (NFILS_MAPA-1) do begin
        for j:= 0 to (NCOLS_MAPA-1) do begin

           if (DatosCeldas[i,j].tipo_esp<>ENEMIGO) and
              (DatosCeldas[i,j].tipo_esp<>PORIGEN) and
              (DatosCeldas[i,j].tipo_esp<>PDESTINO) then begin
                 DibujarCelda(DatosCeldas[i,j]);
           end;
        end;
     end;

     // @@@ se redibujan las celdas para que se vea el borde
     for i:= 0 to (NFILS_MAPA-1) do begin
        for j:= 0 to (NCOLS_MAPA-1) do begin

           if (DatosCeldas[i,j].tipo_esp=ENEMIGO) or
              (DatosCeldas[i,j].tipo_esp=PORIGEN) or
              (DatosCeldas[i,j].tipo_esp=PDESTINO) then begin
                 DibujarCelda(DatosCeldas[i,j]);
           end;
        end;
     end;

     // una vez dibujado todo, se hace el refresco para dibujar el mapa sin parpadeo
     frmMapaCHAC.MapaHEX.Refrescar;

end;

//------------------------------------------------------------------------------

(*
   Procedimiento que pinta el rea que determinan las celdas que estn a una distancia
   igual a un radio dado (capacidad de adquisicin de la unidad).
   La distancia se calcula segn una lnea dibujada con el algoritmo DDA o
   la Distancia Eucldea (segn parmetro).
   Recibe como parmetros:
      - celdau -> celda de la unidad
      - radio_ca -> radio de la zona a dibujar
      - Tablero -> mapa en el que se dibuja
      - max_x -> lmite de columnas del mapa
      - max_y -> lmite de filas del mapa
      - cad_dist -> indica el tipo de distancia a calcular ('DDA' o 'EUCLID')
*)

procedure pintar_area_ca_dist(celdau: t_celda; radio_ca: integer; var Tablero: t_tablero;
                              max_x: integer; max_y: integer; cad_dist: string);
var
   i,j: integer;

   dist: real;
   incx,incy: real;

   celdac: t_celda;

begin

  (** se recorren todos los nodos del mapa **)

  for i:= 0 to (max_y-1) do begin

     for j:=0 to (max_x-1) do begin

        celdac:= Tablero[i,j];

        // si la celda es la misma que la central, no se hace nada
        if (celdac.x = celdau.x) and (celdac.y = celdau.y) then
           continue;

        // se calcula la distancia elegida (DDA o Eucldea)
        if (cad_dist='DDA') then begin
          incx:= 0;  incy:= 0;
          dist:= dist_DDA(celdau,celdac,incx,incy);
        end
        else
          dist:= sqrt( sqr(celdac.x-celdau.x) + sqr(celdac.y-celdau.y) );

        // se mira si la distancia es menor que la capacidad de adquisicin
        // correspondiente y en ese caso se pinta la celda (est dentro de su zona)

        // se colorean de forma diferente las reas de capacidad de adquisicin
        // de la unidad y de los enemigos

        if (celdau.tipo_esp = PORIGEN) then begin

           if (dist<=CAP_ADQ_UNI) then
              // se pinta la celda de la unidad
              frmMapaCHAC.MapaHEX.Pinta1Hex(clYellow,bsCross,Point(celdac.x+1,celdac.y+1),
                                            psSolid,clGray,1,TRUE,FALSE);

        end
        else if (celdau.tipo_esp = ENEMIGO) then begin

           if (dist<=CAP_ADQ_ENE) then
              // se pinta la celda de la unidad
              frmMapaCHAC.MapaHEX.Pinta1Hex(clRed,bsCross,Point(celdac.x+1,celdac.y+1),
                                            psSolid,clGray,1,TRUE,FALSE);
        end;

     end; // for j

  end; // for i

  // se refresca el mapa para ver el rea
  frmMapaCHAC.MapaHEX.Refrescar;


end;

//------------------------------------------------------------------------------

(*
   Procedimiento que pinta el rea hexagonal que determina un radio dado
   (capacidad de adquisicin de la unidad).
   Recibe como parmetros:
      - celdau -> celda de la unidad
      - radio_ca -> radio de la zona hexagonal
      - Tablero -> mapa en el que se dibuja
      - max_x -> lmite de columnas del mapa
      - max_y -> lmite de filas del mapa
*)

procedure pintar_area_ca_hex(celdau: t_celda; radio_ca: integer;
                             var Tablero: t_tablero; max_x: integer; max_y: integer);
var
   i,j,fil,col,c: integer;

   limNO_x, limNO_y: integer;
   inc_nc, num_cels: integer;

   celdac: t_celda;

begin

  // calculamos las coordenadas del punto extremo NorOeste del rea
  // columna (x)
  limNO_x:= celdau.x - radio_ca;

  // si columna final es PAR
  if ((limNO_x mod 2) = 0) then begin
     // fila (y)
     limNO_y:= celdau.y - (radio_ca div 2);
  end
  else begin
     // Columna origen PAR
     if ((celdau.x mod 2) = 0) then
        // fila (y)
        limNO_y:= celdau.y - ((radio_ca div 2)+1)
     else
        // fila (y)
        limNO_y:= celdau.y - (radio_ca div 2);
  end;


  (** se recorren los nodos del rea de izquierda a derecha y de arriba a abajo **)

  // inicializaciones
  fil:= limNO_y;
  col:= limNO_x;

  inc_nc:= 1;
  num_cels:= radio_ca;

  if ((col mod 2)=0) then c:= 1
  else c:= 0;

  (* bucle exterior (de izquierda a derecha). De NorOeste a NorEste *)
  for i:= 1 to ((radio_ca*2)+1) do begin

     // nmero de celdas a explorar (de arriba a abajo)
     num_cels:= num_cels + inc_nc;

     (* bucle interior (de arriba a abajo) *)
     for j:=1 to num_cels do begin

        // si se sale de los lmites, no se hace nada
        if ((fil<0) or (fil>=max_y)) or ((col<0) or (col>=max_x)) then begin
           fil:= fil+1;
           continue;
        end;

        celdac:= Tablero[fil,col];

        // si la celda es la misma que la central, no se hace nada
        if (celdac.x = celdau.x) and (celdac.y = celdau.y) then begin
           fil:= fil+1;
           continue;
        end;

        // se colorean de forma diferente las reas de capacidad de adquisicin
        // de la unidad y de los enemigos
        if (celdau.tipo_esp = PORIGEN) then begin
           // se pinta la celda de la unidad
           frmMapaCHAC.MapaHEX.Pinta1Hex(clYellow,bsCross,Point(celdac.x+1,celdac.y+1),
                                         psSolid,clGray,1,TRUE,FALSE);
        end
        else if (celdau.tipo_esp = ENEMIGO) then begin
           // se pinta la celda de la unidad
           frmMapaCHAC.MapaHEX.Pinta1Hex(clRed,bsCross,Point(celdac.x+1,celdac.y+1),
                                         psSolid,clGray,1,TRUE,FALSE);
        end
        else begin
           // se pinta una celda cualquiera
           frmMapaCHAC.MapaHEX.Pinta1Hex(clYellow,bsSolid,Point(celdac.x+1,celdac.y+1),
                                         psSolid,clBlack,2,TRUE,FALSE);
        end;

        // la fila va cambiando (creciendo hacia abajo)
        fil:= fil+1;

     end; // for j


     // se deja la fila como estaba
     fil:= fil-num_cels;

     c:= c+1;

     // columnas a la izquierda de la central
     if (i<radio_ca) then begin
        if (c=2) then begin
          c:= 0;
          fil:= fil-1;  // cada 2 iteraciones se resta 1
        end;
        col:= col+1;
     end
     // columna central
     else if (i=radio_ca) then begin
        if (c=2) then begin
          fil:= fil-1;  // cada 2 iteraciones se resta 1
        end;

        col:= col+1;

        // se inicializa c en funcin de si la celda est en columna PAR o IMPAR
        if ((col mod 2) = 0) then c:= 0
        else c:= 1;

        //fil:= fil+1;
     end
     // columnas a la derecha de la central
     else begin
        if (c=2) then begin
          c:= 0;
          fil:= fil+1;  // cada 2 iteraciones se suma 1
        end;
        col:= col+1;

        inc_nc:= -1;
     end;


  end; // for i

  // se refresca el mapa para ver el rea
  frmMapaCHAC.MapaHEX.Refrescar;


end;

// --------------------------------------------------------------

procedure pintar_VO_zona_ca();
var
   i,j,e: integer;

   celdadib: TDibCelda;
   pos: TPoint;

   vista: boolean;
   VO: integer;

begin

  // recorremos las celdas y comprobamos si son vistas por algn enemigo u ocultas a todos
  for i:= 0 to (NFILS_MAPA-1) do begin
     for j:= 0 to (NCOLS_MAPA-1) do begin

        // los enemigos no se comprueban
        if (DatosCeldas[i,j].tipo_esp = ENEMIGO) then begin
            continue;
        end;

        vista:= FALSE;

        // comprobamos cada celda desde todos los enemigos
        for e:=0 to (num_enemigos-1) do begin

            VO:= celda_VO(DatosCeldas[i,j],ENEMIGOS[e],DatosCeldas,(NCOLS_MAPA-1),(NFILS_MAPA-1));
            if (VO = 1) then begin
               vista:= TRUE;
               break;
            end;

        end;

        // si es oculta, se cambia el estilo de relleno de la celda
        if (vista = FALSE) then begin
           pos.x:=j+1;
           pos.y:=i+1;

           // se obtienen los datos de dibujo de la celda en cuestin
           celdadib:= frmMapaCHAC.MapaHEX.DatosDibHexa(pos.x,pos.y);

           celdadib.color_relleno:= clBlack;
           // estilo de relleno con diagonales cruzadas
           celdadib.estilo_relleno:= bsDiagCross;
         (*
          // si es oculta a todos los enemigos, se marca en rosa (si hay enemigos)
          if (num_enemigos > 0) then begin
             celdadib.color_borde:= clFuchsia;  // se cambia el color del borde
             celdadib.grosor_borde:= 2;
          end;
          *)

           // Pintamos el Hexgono (no se refresca automticamente)
           frmMapaCHAC.MapaHEX.Pinta1Hex(celdadib.color_relleno,celdadib.estilo_relleno,pos,
                    celdadib.estilo_borde,celdadib.color_borde,celdadib.grosor_borde,TRUE,FALSE);

        end;  // if vista = FALSE


     end;  // for j

  end;  // for i

  // una vez dibujado todo, se hace el refresco para dibujar el mapa sin parpadeo
  frmMapaCHAC.MapaHEX.Refrescar;

end;

// --------------------------------------------------------------

(*
   Procedimiento que escribe el fichero con los datos del mapa
   Recibe como parmetros:
      - nombre_fichero -> fichero en el que se guardarn los datos
*)
procedure GuardarMapa(nombre_fichero: string);
var
   fich_mapa: File of t_celda;
   celda_aux: t_celda;
   i,j: integer;

   cad_aux: string;

   // fichero de eventos
   nombre_fich_evens: string;
   fich_evens: TextFile;

   // datos relevantes del mapa
   unidad: t_celda;
   destino: t_celda;
   enemigos: array of t_celda;
   num_enemigos: integer;

begin

  // se abre el fichero para escritura
  AssignFile(fich_mapa, nombre_fichero);
  ReWrite(fich_mapa);

  // guardamos una celda con el tamao del mapa (x->filas,y->columnas)
  celda_aux.y:= NFILS_MAPA;
  celda_aux.x:= NCOLS_MAPA;
  Write(fich_mapa,celda_aux);

  num_enemigos:= 0;

  // creamos las celdas del mapa
  for i:= 0 to (NFILS_MAPA-1) do begin
     for j:= 0 to (NCOLS_MAPA-1) do begin

        Write(fich_mapa,DatosCeldas[i,j]);

        // Guardamos los datos relevantes del mapa (unidad, destino y enemigos)
        // en base al tipo especial de celda
        if (DatosCeldas[i,j].tipo_esp = PORIGEN) then
           unidad := DatosCeldas[i,j]
        else if (DatosCeldas[i,j].tipo_esp = PDESTINO) then
           destino := DatosCeldas[i,j]
        else if (DatosCeldas[i,j].tipo_esp = ENEMIGO) then begin
           num_enemigos:= num_enemigos+1;
           SetLength(enemigos,num_enemigos);
           enemigos[num_enemigos-1]:= DatosCeldas[i,j];
        end;

     end;
  end;

  // cerramos el fichero
  CloseFile(fich_mapa);

  // guardamos el nombre del fichero
  MapaActual:= nombre_fichero;

  // Ponemos el nombre del mapa en el ttulo del form
  cad_aux:= frmMapaCHAC.Caption;
  delete(cad_aux,17,200);
  frmMapaCHAC.Caption:= cad_aux + ' - [' + MapaActual + ']';

  // ----------------- FICHERO DE EVENTOS ------------------------
(*
  // se crea el nombre
  nombre_fich_evens:= ChangeFileExt(ExtractFileName(nombre_fichero),'.eve');

  // se crea
  AssignFile(fich_evens, nombre_fich_evens);
  Rewrite(fich_evens);

  // Fichero de Eventos del Mapa
  Writeln(fich_evens, ';*****************************************************************************');
  Writeln(fich_evens, ';     Fichero de Eventos del mapa: ' + ExtractFileName(nombre_fichero));
  Writeln(fich_evens, ';*****************************************************************************');
  Writeln(fich_evens,'');
  Writeln(fich_evens,'');

  // Valores iniciales del Mapa
  Writeln(fich_evens, ';--- Datos iniciales del mapa ---');
  Writeln(fich_evens, '[MAPA_INICIAL]');
  Writeln(fich_evens, 'TamX = ' + IntToStr(NCOLS_MAPA));
  Writeln(fich_evens, 'TamY = ' + IntToStr(NFILS_MAPA));
  Writeln(fich_evens, 'Enemigos = ' + IntToStr(num_enemigos));
  Writeln(fich_evens,'');

  Writeln(fich_evens, ';- Situacin inicial de la Unidad');
  Writeln(fich_evens, '[UNIDAD]');
  Writeln(fich_evens, 'X = ' + IntToStr(unidad.x));
  Writeln(fich_evens, 'Y = ' + IntToStr(unidad.y));
  Writeln(fich_evens,'');

  Writeln(fich_evens, ';- Destino a alcanzar');
  Writeln(fich_evens, '[DESTINO]');
  Writeln(fich_evens, 'X = ' + IntToStr(destino.x));
  Writeln(fich_evens, 'Y = ' + IntToStr(destino.y));
  Writeln(fich_evens,'');

  // escribimos los datos de los enemigos iniciales
  Writeln(fich_evens, ';- Enemigos iniciales en el mapa');
  for j:= 0 to num_enemigos-1 do begin
      Writeln(fich_evens, '[ENEMIGO_' + IntToStr(j)+']');
      Writeln(fich_evens, 'X = ' + IntToStr(enemigos[j].x));
      Writeln(fich_evens, 'Y = ' + IntToStr(enemigos[j].y));
  end;

  Writeln(fich_evens,'');
  Writeln(fich_evens,'');

  // escribimos los posibles eventos (en blanco para rellenar por el usuario)
  Writeln(fich_evens, ';--- LISTA DE EVENTOS POSIBLES ---');
  Writeln(fich_evens, ';- (A completar por el usuario) -');
  Writeln(fich_evens,'');
  Writeln(fich_evens,';- indicar nmero de eventos que hay (etiquetas) y nombrarlos ''EVENTO_N'', con N un nmero entero');
  Writeln(fich_evens,';- para deshabilitar un evento, asignarle la iteracin = -1');
  Writeln(fich_evens,'');
  Writeln(fich_evens, 'Posibles Acciones = IE -> insertar enemigo');
  Writeln(fich_evens, '                    DE -> eliminar enemigo');
  Writeln(fich_evens, '                    ME -> mover enemigo');
  Writeln(fich_evens, '                    MD -> mover destino)');
  Writeln(fich_evens,'');
  Writeln(fich_evens,'[DATOS_EVENTOS]');
  Writeln(fich_evens,'Numero_eventos = 10');
  Writeln(fich_evens,'');

  for j:= 1 to 10 do begin
      Writeln(fich_evens, '[EVENTO_' + IntToStr(j) + ']');
      Writeln(fich_evens, 'Iteracion = -1');
      Writeln(fich_evens, 'Accion = ');
      Writeln(fich_evens, 'Xactual = ');
      Writeln(fich_evens, 'Yactual = ');
      Writeln(fich_evens, 'Xsiguiente = ');
      Writeln(fich_evens, 'Ysiguiente = ');
      Writeln(fich_evens,'');
  end;

  // Cerramos el fichero
  Flush(fich_evens);
  CloseFile(fich_evens);
*)
  // liberamos el array de enemigos
  Finalize(enemigos);

 // showmessage('Fichero Guardado Correctamente (se ha creado el fichero de eventos)');

  showmessage('File correctly saved');

end;

// --------------------------------------------------------------

(*
   Procedimiento que copia los datos relevantes para la simulacin al
   array de datos de celdas a partir de los datos del editor.
   Recibe como parmetros:
      - ind_f -> ndice de la fila de la celda a copiar
      - ind_c -> ndice de la columna de la celda a copiar
*)
procedure GuardarDatosCelda(ind_f: integer; ind_c: integer);

var
  alt: integer;

begin

  // ndices de las celdas
  DatosCeldas[ind_f,ind_c].x:= ind_c;
  DatosCeldas[ind_f,ind_c].y:= ind_f;

  // altura (depende el tipo de celda)
  alt:= frmMapaCHAC.trAltura.Position;
  DatosCeldas[ind_f,ind_c].altura:= (alt * -1); // el control est al revs

  // tipo de celda, dao por defecto y recursos por defecto
  if (frmMapaCHAC.rbtnCeldaNormal.Checked=TRUE) then begin
      DatosCeldas[ind_f,ind_c].tipo:= NORM;
      DatosCeldas[ind_f,ind_c].danio_0:= DANIO_0_NORM;
      DatosCeldas[ind_f,ind_c].recursos_0:= RECURSOS_0_NORM;
  end
  else if (frmMapaCHAC.rbtnCeldaAgua.Checked=TRUE) then begin
      DatosCeldas[ind_f,ind_c].tipo:= AGUA;
      DatosCeldas[ind_f,ind_c].danio_0:= DANIO_0_AGUA;
      DatosCeldas[ind_f,ind_c].recursos_0:= RECURSOS_0_AGUA;
  end
  else if (frmMapaCHAC.rbtnCeldaBosque.Checked=TRUE) then begin
      DatosCeldas[ind_f,ind_c].tipo:= BOSQ;
      DatosCeldas[ind_f,ind_c].danio_0:= DANIO_0_BOSQ;
      DatosCeldas[ind_f,ind_c].recursos_0:= RECURSOS_0_BOSQ;
  end
  else if (frmMapaCHAC.rbtnCeldaOBSTACULO.Checked=TRUE) then begin
      DatosCeldas[ind_f,ind_c].tipo:= OBST;
      DatosCeldas[ind_f,ind_c].danio_0:= DANIO_0_OBST;
      DatosCeldas[ind_f,ind_c].recursos_0:= RECURSOS_0_OBST;
  end;

  // tipo especial de celda
  if (frmMapaCHAC.rbtnCIAOrigen.Checked=TRUE) then
      DatosCeldas[ind_f,ind_c].tipo_esp:= PORIGEN
  else if (frmMapaCHAC.rbtnCIADestino.Checked=TRUE) then
      DatosCeldas[ind_f,ind_c].tipo_esp:= PDESTINO
  else if (frmMapaCHAC.rbtnLetalidad.Checked=TRUE) then
      DatosCeldas[ind_f,ind_c].tipo_esp:= IMPARMA
  else if (frmMapaCHAC.rbtnSituacionEnemigo.Checked=TRUE) then
      DatosCeldas[ind_f,ind_c].tipo_esp:= ENEMIGO
  else
      DatosCeldas[ind_f,ind_c].tipo_esp:= NO;

  // dao que produce la celda por impacto de arma (onda expansiva)
  if (frmMapaCHAC.rbtnLetalidad.Checked=TRUE) then
     DatosCeldas[ind_f,ind_c].danio_arma:= frmMapaCHAC.trLetalidad.Position
  else
      DatosCeldas[ind_f,ind_c].danio_arma:= 0.0;  // no hay impacto

end;

// --------------------------------------------------------------

(*
   Procedimiento que cambia el aspecto de la celda cuyos ndices se pasan y
   la convierte en una celda de impacto de armas con el dao asociado.
   Recibe como parmetros:
      - ind_f -> ndice de la fila de la celda a cambiar
      - ind_c -> ndice de la columna de la celda a cambiar
      - danio_arma -> dao asociado a la celda (para dibujarla de un color determinado)
*)
procedure CambiarCeldaVista(ind_f: integer; ind_c: integer; danio_arma: single);

var
   color_cel: TColor;
   grosor_borde: integer;
   color_borde: integer;

   pos: TPoint;

begin

   // habr unos colores en funcin del impacto del arma
     if (danio_arma > 0) and (danio_arma <= DANIO_NIVEL_1) then
        color_cel:= COLDANIO_N1_25   // 1-25 de dao
     else if (danio_arma > DANIO_NIVEL_1) and (danio_arma <= DANIO_NIVEL_2) then
        color_cel:= COLDANIO_N25_50   // 26-50 de dao
     else if (danio_arma > DANIO_NIVEL_2) and (danio_arma <= DANIO_NIVEL_3) then
        color_cel:= COLDANIO_N50_75   // 51-75 de dao
     else if (danio_arma > DANIO_NIVEL_3) and (danio_arma <= DANIO_NIVEL_4) then
        color_cel:= COLDANIO_N75_100;  // 76-100 de dao

     color_borde:= clGray;
     grosor_borde:= 1;

     // Dibujamos el Hexgono con los parmetros elegidos
     pos.x := ind_c+1;
     pos.y := ind_f+1;

     // si est la imagen de fondo no se sobreescribe
     if (frmMapaCHAC.chkVerImagen.Checked=TRUE) then
        // no se refresca al dibujar
        frmMapaCHAC.MapaHEX.PintaBordeHex(pos,color_borde,grosor_borde,color_borde,grosor_borde,
                                          color_borde,grosor_borde,color_borde,grosor_borde,
                                          color_borde,grosor_borde,color_borde,grosor_borde,FALSE)
     else
        // no se refresca al dibujar
        frmMapaCHAC.MapaHEX.Pinta1Hex(color_cel,bsSolid,pos,psSolid,color_borde,grosor_borde,TRUE,FALSE);

end;

// --------------------------------------------------------------

(*
   Procedimiento que marca las celdas alrededor de un enemigo como zonas
   de impacto de armas (en diferentes medidas) y guarda los datos de dichas
   celdas.
   Recibe como parmetros:
      - ind_f -> ndice de la fila de la celda con la situacin del enemigo
      - ind_c -> ndice de la columna de la celda con la situacin del enemigo
*)
procedure MarcarZonaAtaqueEnemigo(ind_f: integer; ind_c: integer);

var
  i,j: integer;

  cel_f, cel_c: integer;

begin

   // si no hay enemigo en la plantilla, es errnea y no se hace nada
   if (POS_PLANT_ENE_fil=-1) or (POS_PLANT_ENE_col=-1) then exit;

   // Recorremos la plantilla y vamos pintando las celdas de la misma (con el dao marcado)
   for i:=0 to (NFILS_PLANT_ZA - 1) do begin
      for j:=0 to (NCOLS_PLANT_ZA - 1) do begin

         cel_f:= ind_f - (POS_PLANT_ENE_fil - i);  // fila de la celda a pintar en el mapa
         cel_c:= ind_c - (POS_PLANT_ENE_col - j);  // columna de la celda a pintar en el mapa

         // si la columna incial es par y la que se va a pintar tambin,
         // se suma 1 a las coordenadas de la fila de la celda
         if (POS_PLANT_ENE_col mod 2 = 0) then begin
            if (((ind_c mod 2) <> 0) and ((cel_c mod 2) = 0)) then
               cel_f:= cel_f + 1;
         end
         else
            if (((ind_c mod 2) = 0) and ((cel_c mod 2) <> 0)) then
               cel_f:= cel_f - 1;

         // si se sale de las coordenadas, no se pinta
         if (cel_f < 0) or (cel_f>=NFILS_MAPA) then continue;
         if (cel_c < 0) or (cel_c>=NCOLS_MAPA) then continue;

         // si la celda tiene altura ALT_VACIA (-10000) o dao menor de 1 es que es vaca,
         // por lo que no es zona de impacto y no se hace nada
         if (zona_ataque_enemigo[i,j].altura=ALT_VACIA) or
            (zona_ataque_enemigo[i,j].danio_arma < 1) then continue;

         // si es un obstculo, no se cambian sus datos
         if (DatosCeldas[cel_f,cel_c].tipo <> OBST) then begin
            // cambiamos el aspecto visual de la celda
            CambiarCeldaVista(cel_f,cel_c,zona_ataque_enemigo[i,j].danio_arma);

            // modificamos los datos de la celda
            DatosCeldas[cel_f,cel_c].tipo_esp:= IMPARMA;
            DatosCeldas[cel_f,cel_c].danio_arma:= zona_ataque_enemigo[i,j].danio_arma;
         end;

      end;
   end;

  // @@@ se redibujan las celdas de origen, destino y enemigos para
  // @@@ que se vea bien el borde
  for i:= 0 to (NFILS_MAPA-1) do begin
     for j:= 0 to (NCOLS_MAPA-1) do begin

        if (DatosCeldas[i,j].tipo_esp=ENEMIGO) or
           (DatosCeldas[i,j].tipo_esp=PORIGEN) or
           (DatosCeldas[i,j].tipo_esp=PDESTINO) then begin
           DibujarCelda(DatosCeldas[i,j]);
        end;

     end;
  end;

   // una vez dibujado todo, se hace el refresco para dibujar las nuevas celdas
   frmMapaCHAC.MapaHEX.Refrescar;

end;

// --------------------------------------------------------------

(*
   Funcin que busca las celdas origen y destino.
   Recibe como parmetros:
      - ODE -> indica si buscamos la celda origen ('O'), la celda destino ('D')
               o la celda enemigo ('E')
   Devuelve:
      - TRUE si se encuentra la celda y FALSE si no se encuentra
      - celda_ode -> la celda encontrada
*)
function BuscarOrigenDestinoEnemigo(ODE: string; var celda_ode: t_celda): boolean;

var
   i,j: integer;

begin

  // buscamos las celdas ORIGEN, DESTINO o ENEMIGO en el mapa
  for i:= 0 to (NFILS_MAPA-1) do begin

     for j:= 0 to (NCOLS_MAPA-1) do begin

        if (ODE = 'O') and (DatosCeldas[i,j].tipo_esp = PORIGEN) then begin
            celda_ode:= DatosCeldas[i,j];
            Result:= true;
            exit;
        end;

        if (ODE = 'D') and (DatosCeldas[i,j].tipo_esp = PDESTINO) then begin
            celda_ode:= DatosCeldas[i,j];
            Result:= true;
            exit;
        end;

        if (ODE = 'E') and (DatosCeldas[i,j].tipo_esp = ENEMIGO) then begin
            celda_ode:= DatosCeldas[i,j];
            Result:= true;
            exit;
        end;

     end;  // for j

  end;  // for i

  Result:= false;

end;

// --------------------------------------------------------------

(*
   Procedimiento que busca las celdas con enemigos.
   Guarda el el vector de enemigos los resultados. 
*)
procedure BuscarEnemigos({enemigos: array of t_celda; var num_enemigos: t_celda});

var
   i,j: integer;

begin

  num_enemigos:= 0;
  SetLength(ENEMIGOS,num_enemigos);

  // buscamos las celdas de los ENEMIGOS en el mapa
  for i:= 0 to (NFILS_MAPA-1) do begin

     for j:= 0 to (NCOLS_MAPA-1) do begin

        if (DatosCeldas[i,j].tipo_esp = ENEMIGO) then begin
            num_enemigos:= num_enemigos + 1;
            SetLength(ENEMIGOS,num_enemigos);
            ENEMIGOS[(num_enemigos-1)]:= DatosCeldas[i,j];
        end;

     end;  // for j

  end;  // for i

end;

//------------------------------------------------------------------------------

(* @@@
   Funcin que comprueba si una celda pertenece al vecindario de otra en un
   grid hexagonal y devuelve su nmero de vecino, considerando como nmero 1
   el vecino noroeste y como nmero 6 el vecino suroeste.
   Recibe como parmetros:
      - fila -> fila del nodo actual
      - columna -> columna del nodo actual
      - fila_v -> fila del vecino
      - columna_v -> columna del vecino
   Devuelve:
      - el Nmero de Vecino si el nodo es vecino en un grid hexagonal
        y 0 en caso contrario
*)
function num_vecino_hexa (fila: integer; columna: integer;
                          fila_v: integer; columna_v: integer): integer;
begin

  // @@@ Si se sale de alguno de los lmites del tablero no sern vecinos
  if (fila_v < 0) or (fila_v >= NFILS_MAPA) then begin
     Result:= 0;
     exit;
  end;

  // @@@ si se sale de los lmites del tablero, ya que no ser un nodo a atravesar
  if (columna_v < 0) or (columna_v >= NCOLS_MAPA) then begin
     Result:= 0;
     exit;
  end;

  // @@@ si distan ms de 1 en algn sentido, no sern vecinos
  if (abs(fila-fila_v)>1) or (abs(columna-columna_v)>1) then begin
     Result:= 0;
     exit;
  end;

  // Columna PAR
  if ((columna mod 2) = 0) then begin

     // @@@ La celda no ser vecino en el hexgono si:
     // @@@ La columna de la central es PAR y las coordenadas de la posible vecina son
     // @@@ (fil+1,col-1) o (fil+1,col+1)
     if ((fila_v = (fila+1)) and (columna_v = (columna-1))) or
        ((fila_v = (fila+1)) and (columna_v = (columna+1))) then begin
        Result:= 0;
        exit;
     end;

     // si es vecino, su nmero ser:

     if (fila_v = (fila-1)) and (columna_v = (columna-1)) then
        Result:=1  // vecino 1
     else if (fila_v = (fila-1)) and (columna_v = columna) then
        Result:=2  // vecino 2
     else if (fila_v = (fila-1)) and (columna_v = (columna+1)) then
        Result:=3  // vecino 3
     else if (fila_v = fila) and (columna_v = (columna+1)) then
        Result:=4  // vecino 4
     else if (fila_v = (fila+1)) and (columna_v = columna) then
        Result:=5  // vecino 5
     else if (fila_v = fila) and (columna_v = (columna-1)) then
        Result:=6;  // vecino 6

  end
  // Columna IMPAR
  else begin

     // @@@ La celda no ser vecino en el hexgono si:
     // @@@ Su columna es IMPAR y las coordenadas de la posible vecina son
     // @@@ (fil-1,col-1) o (fil-1,col+1)
     if ((fila_v = (fila-1)) and (columna_v = (columna-1))) or
        ((fila_v = (fila-1)) and (columna_v = (columna+1))) then begin
        Result:= 0;
        exit;
     end;

     // si es vecino, su nmero ser:

     if (fila_v = fila) and (columna_v = (columna-1)) then
        Result:=1  // vecino 1
     else if (fila_v = (fila-1)) and (columna_v = columna) then
        Result:=2  // vecino 2
     else if (fila_v = fila) and (columna_v = (columna+1)) then
        Result:=3  // vecino 3
     else if (fila_v = (fila+1)) and (columna_v = (columna+1)) then
        Result:=4  // vecino 4
     else if (fila_v = (fila+1)) and (columna_v = columna) then
        Result:=5  // vecino 5
     else if (fila_v = (fila+1)) and (columna_v = (columna-1)) then
        Result:=6;  // vecino 6

  end;

end;

// --------------------------------------------------------------
// --------------------------------------------------------------

procedure TfrmMapaCHAC.btnEjecutarClick(Sender: TObject);

var
  celda_ode: t_celda;

begin

   // comprobamos que estn las celdas Origen y Destino
   if (BuscarOrigenDestinoEnemigo('O',celda_ode) = TRUE) and
      (BuscarOrigenDestinoEnemigo('D',celda_ode) = TRUE) then begin

      // mostramos la pantalla de seleccin de parmetros de CHAC
      with TfmrParametrosCHAC.Create(Self) do
      begin

          // se indica si hay enemigo visto o no
          enemigo_conocido:= BuscarOrigenDestinoEnemigo('E',celda_ode);

          edFicheroMapa.Text:= MapaActual;
          ShowModal;

          // se comprueba si hay soluciones y si hay, se cargan y se muestran
          if (num_soluciones > 0) then begin

             // se limpia la solucin anterior
             if (num_sols_mostradas > 0) then begin
                LimpiarMarcasMapa();
                num_sols_mostradas:= 0;
             end;

             // se inicializa
             sol_anterior:= -1;

             // se cargan las soluciones del fichero
             CargarSoluciones(fichero_soluciones);

             // se muestran las soluciones en la lista
             MostrarListaSoluciones();

             soluciones_cargadas:= TRUE;
             btnMostrarSolucion.Enabled:= TRUE;

             // mostramos los detalles de la primera
             sgSolucionesClick(Self);

             // buscamos los enemigos
             BuscarEnemigos();

          end;

          Release;
      end;

   end
   else begin
      ShowMessage('You must define an Origin and a Destination cell');
   end;

end;

// --------------------------------------------------------------

procedure TfrmMapaCHAC.FormCreate(Sender: TObject);

begin

  // Leemos los datos del fichero INI
  leer_ini();

  // Inicializamos las variables
  NFILS_MAPA:= 30;
  NCOLS_MAPA:= 30;
  RADIO_CELDA:= 12;

  CrearMapa(PanelMapa,0,0);

  rbtn30x30.Checked:= TRUE;
  rbtnCeldaNormal.Checked:= TRUE;

  // @@@ Informamos de las dimensiones del mapa
  frmMapaCHAC.txtInfoDimensiones.Text:= ' ' + IntToStr(NFILS_MAPA) + ' Rows x '
                                            + IntToStr(NCOLS_MAPA) + ' Cols | Rad = '
                                            + IntToStr(RADIO_CELDA);
  // Imagen de Fondo vaca
  MapaHex.MapImageName:='';

  // Ponemos nombre a las columnas del String Grid de Soluciones
  sgSoluciones.Cells[0,0]:='N';
  sgSoluciones.Cells[1,0]:='Resources Cost';
  sgSoluciones.Cells[2,0]:='Health Cost';

  // ponemos soluciones cargadas a FALSE
  soluciones_cargadas:= FALSE;
  btnMostrarSolucion.Enabled:= FALSE;

  // ponemos eventos cargados a FALSE
  eventos_cargados:= FALSE;

  mapa_cargado:= FALSE;

  sol_anterior:= -1;
  num_sols_mostradas:= 0;

end;

// --------------------------------------------------------------

procedure TfrmMapaCHAC.PanelMapaMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);

var
   ind_c,ind_f: integer;
   pos: TPoint;
   celda_od: t_celda;

begin

  // en modo info no se dibuja nada
  if (chkModoInfo.Checked=TRUE) then begin
     exit;
  end;

// @@@  ind_x:= X div TAMX_CELDA;
// @@@  ind_y:= Y div TAMY_CELDA;

  pos.x:= X;
  pos.y:= Y;
  pos:= MapaHEX.ConvertCoords(pos,ptXY);
  // los ndices en la matriz de celdas empiezan en [0,0]
  ind_c:= pos.x-1;
  ind_f:= pos.y-1;

  // si se pulsa fuera del mapa, las coordenadas sern 0 (y los ndices -1)
  if (ind_c < 0) or (ind_f < 0) then exit;

  // aseguramos que los ndices no se salgan de los lmites
  if ind_c > (NCOLS_MAPA-1) then ind_c:= NCOLS_MAPA-1;
  if ind_f > (NFILS_MAPA-1) then ind_f:= NFILS_MAPA-1;

  // comprobamos si se desea dibujar un nodo origen o destino y ya hay otro
  if (rbtnCIAOrigen.Checked=TRUE)then begin
     if (BuscarOrigenDestinoEnemigo('O',celda_od) = TRUE) and
        ((celda_od.x <> ind_c) or (celda_od.y <> ind_f)) then begin
        showmessage ('There is an Origin cell yet');
        exit;
     end;
  end;
  if (rbtnCIADestino.Checked=TRUE)then begin
     if (BuscarOrigenDestinoEnemigo('D',celda_od) = TRUE) and
        ((celda_od.x <> ind_c) or (celda_od.y <> ind_f)) then begin
        showmessage ('There is a Destination cell yet');
        exit;
     end;
  end;


  // copiamos las caractersticas de la celda de muestra a la que hemos
  // hecho click (dibujamos esta ltima)

  // convertimos las coordenadas del punto a Fila/Columna para dibujarlo
  pos.x:= X;
  pos.y:= Y;
  pos:= frmMapaCHAC.MapaHEX.ConvertCoords(pos,ptXY);

  // si est la imagen de fondo no se sobreescribe
  if (frmMapaCHAC.chkVerImagen.Checked=TRUE) then
     // dibujamos la celda (se refresca automticamente para que se vea)
     frmMapaCHAC.MapaHEX.Pinta1Hex(CeldaMuestra.Brush.Color,bsSolid,pos,psSolid,
                                   CeldaMuestra.Pen.Color,CeldaMuestra.Pen.Width,FALSE,TRUE)
  else
     frmMapaCHAC.MapaHEX.Pinta1Hex(CeldaMuestra.Brush.Color,bsSolid,pos,psSolid,
                                   CeldaMuestra.Pen.Color,CeldaMuestra.Pen.Width,TRUE,TRUE);
// @@@
// @@@
// @@@

  // guardamos los datos para simulacin de las celdas (fila,columna)
  // @@@ est bien la fila (y) y columna (x) ???
  GuardarDatosCelda(ind_f,ind_c);

  // si se trata de un enemigo y tenemos marcada la opcin de marcar zona de ataque
  // se marcan las celdas de alrededor como celdas de impacto de arma (y su killing)
  // adems se guardan sus datos como tales
  if (frmMapaCHAC.rbtnSituacionEnemigo.Checked=TRUE) and
     (chkMarcarZonaAtaque.Checked=TRUE) then begin
     // @@@ est bien la fila (y) y columna (x) ???
     MarcarZonaAtaqueEnemigo(ind_f,ind_c);
  end;

end;

// --------------------------------------------------------------

procedure TfrmMapaCHAC.PanelMapaMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
   ind_c,ind_f: integer;
   celda_od: t_celda;
   pos: TPoint;

begin

// @@@  // ndices de la celda seleccionada
// @@@  ind_x:= X div TAMX_CELDA;
// @@@  ind_y:= Y div TAMY_CELDA;

  pos.x:= X;
  pos.y:= Y;
  pos:= MapaHEX.ConvertCoords(pos,ptXY);
  // los ndices en la matriz de celdas empiezan en [0,0]
  ind_c:= pos.x-1;
  ind_f:= pos.y-1;

  // si se pulsa fuera del mapa, las coordenadas sern 0 (y los ndices -1)
  if (ind_c < 0) or (ind_f < 0) then exit;

  // aseguramos que los ndices no se salgan de los lmites
  if ind_c > (NCOLS_MAPA-1) then ind_c:= NCOLS_MAPA-1;
  if ind_f > (NFILS_MAPA-1) then ind_f:= NFILS_MAPA-1;

// @@@  if ind_c < 0 then ind_c:= 0;
// @@@  if ind_f < 0 then ind_f:= 0;

  // si tenemos el botn pulsado, no se mostrar la info
  if not(ssLeft in Shift) then begin

     // coordenadas
     txtInfoCelda.Text:= '[' + intToStr(DatosCeldas[ind_f,ind_c].x) + ','
                             + intToStr(DatosCeldas[ind_f,ind_c].y) + '] ';
     // tipo de celda
     case (DatosCeldas[ind_f,ind_c].tipo) of
        NORM: txtInfoCelda.Text:= txtInfoCelda.Text + ' NORMAL (FLAT)';
        AGUA: txtInfoCelda.Text:= txtInfoCelda.Text + ' WATER';
        BOSQ: txtInfoCelda.Text:= txtInfoCelda.Text + ' FOREST';
        OBST: txtInfoCelda.Text:= txtInfoCelda.Text + ' OBSTACLE';
     end;

     txtInfoCelda.Text:= txtInfoCelda.Text + '  ,  Hgt = ' + inttoStr(DatosCeldas[ind_f,ind_c].altura);

     // tipo especial de celda
     case (DatosCeldas[ind_f,ind_c].tipo_esp) of
        PORIGEN: txtInfoCelda.Text:= txtInfoCelda.Text + '  ,  [Unit ORIGIN Point]';
        PDESTINO: txtInfoCelda.Text:= txtInfoCelda.Text + '  ,  [TARGET Point]';
        ENEMIGO: txtInfoCelda.Text:= txtInfoCelda.Text + '  ,  [ENEMY]';
        IMPARMA: txtInfoCelda.Text:= txtInfoCelda.Text + '  ,  [WEAPON IMPACT (' +
                                     FloatToStr(DatosCeldas[ind_f,ind_c].danio_arma) + ')]';
     end;

     txtInfoCelda.Text:= txtInfoCelda.Text + '  |  (d0=' + FloatToStrF(DatosCeldas[ind_f,ind_c].danio_0,ffGeneral,2,3) +
                                             '-r0=' + FloatToStrF(DatosCeldas[ind_f,ind_c].recursos_0,ffGeneral,2,3) + ')';

  end;



  // solo se dibuja si se pulsa el botn del ratn y no se est en modo info
  if (ssLeft in Shift) and (chkModoInfo.Checked=FALSE) then begin

     // comprobamos si se desea dibujar un nodo origen o destino y ya hay otro
     if (rbtnCIAOrigen.Checked=TRUE)then begin
        if (BuscarOrigenDestinoEnemigo('O',celda_od) = TRUE) then begin
            ShowMessage ('There is an Origin cell yet');
            exit;
        end;
     end;
     if (rbtnCIADestino.Checked=TRUE)then begin
        if (BuscarOrigenDestinoEnemigo('D',celda_od) = TRUE) then begin
            ShowMessage ('There is an Target cell yet');
            exit;
        end;
     end;

     // controlamos que no nos salgamos del panel al dibujar
     if (X<3) then X:=3;
     if (X>(PanelMapa.Width-10)) then X:= PanelMapa.Width-10;
     if (Y<3) then Y:=3;
     if (Y>(PanelMapa.Height-10)) then Y:= PanelMapa.Height-10;


     // copiamos las caractersticas de la celda de muestra a la que hemos
     // hecho click (dibujamos esta ltima)

     // convertimos las coordenadas del punto a Fila/Columna
     pos.x:= X;
     pos.y:= Y;
     pos:= frmMapaCHAC.MapaHEX.ConvertCoords(pos,ptXY);

     // si est la imagen de fondo no se sobreescribe
     if (frmMapaCHAC.chkVerImagen.Checked=TRUE) then
        // dibujamos la celda (se refresca automticamente para que se vea)
        frmMapaCHAC.MapaHEX.Pinta1Hex(CeldaMuestra.Brush.Color,bsSolid,pos,psSolid,
                                      CeldaMuestra.Pen.Color,CeldaMuestra.Pen.Width,FALSE,TRUE)
     else
        // dibujamos la celda (se refresca automticamente para que se vea)
        frmMapaCHAC.MapaHEX.Pinta1Hex(CeldaMuestra.Brush.Color,bsSolid,pos,psSolid,
                                      CeldaMuestra.Pen.Color,CeldaMuestra.Pen.Width,TRUE,TRUE);

// @@@
// @@@
// @@@

     // guardamos los datos para simulacin de las celdas (fila,columna)
     // @@@ est bien la fila (y) y columna (x) ???
     GuardarDatosCelda(ind_f,ind_c);

  end;

  // si la celda es blanca (altura = ALT_VACIA (-10000)), no tendr datos
  if DatosCeldas[ind_f,ind_c].altura = -10000 then begin
     txtInfoCelda.Text:= 'EMPTY';
     exit;
  end;

end;

// --------------------------------------------------------------

procedure TfrmMapaCHAC.rbtnCeldaNormalClick(Sender: TObject);
var
   pos: TPoint;

begin

   // Marrn Normal
   CeldaMuestra.Brush.Color:= COLNORM_AL0;
   CeldaMuestra.Brush.Style:= bsSolid;
   CeldaMuestra.Shape:= stRectangle;

   CeldaMuestra.Pen.Color:= clGray;
   CeldaMuestra.Pen.Width:= 1;

   // se dibuja el hexgono de muestra
   pos.X:= 1;
   pos.Y:= 1;

   // se refresca automticamente para que se vea
   HexaMuestra.Pinta1Hex(CeldaMuestra.Brush.Color,bsSolid,pos,psSolid,
                         CeldaMuestra.Pen.Color,CeldaMuestra.Pen.Width,TRUE,TRUE);

   // altura media
   trAltura.Enabled:= TRUE;
   lblAltura.Enabled:= TRUE;
   trAltura.Position:= 0;

   // se quitan los radio buttons
   rbtnSituacionEnemigo.Checked:= FALSE;
   rbtnLetalidad.Checked:= FALSE;
   rbtnCIADestino.Checked:= FALSE;
   rbtnCIAOrigen.Checked:= FALSE;

   grbxUnidadesBatalla.Enabled:= TRUE;
   grbxUnidadesBatalla.Font.Color:= clBlack;
   ColorTipoCelda:= CeldaMuestra.Brush.Color;

   lblLetalidad.Caption:= '[ ]';
end;

// --------------------------------------------------------------

procedure TfrmMapaCHAC.rbtnCeldaAguaClick(Sender: TObject);
var
   pos: TPoint;

begin
   // Azul Normal
   CeldaMuestra.Brush.Color:= COLAGUA_AL0;
   CeldaMuestra.Brush.Style:= bsSolid;
   CeldaMuestra.Shape:= stRectangle;

   CeldaMuestra.Pen.Color:= clGray;
   CeldaMuestra.Pen.Width:= 1;

   // se dibuja el hexgono de muestra
   pos.X:= 1;
   pos.Y:= 1;

   // se refresca automticamente para que se vea
   HexaMuestra.Pinta1Hex(CeldaMuestra.Brush.Color,bsSolid,pos,psSolid,
                         CeldaMuestra.Pen.Color,CeldaMuestra.Pen.Width,TRUE,TRUE);

   // altura media
   trAltura.Enabled:= TRUE;
   lblAltura.Enabled:= TRUE;
   trAltura.Position:= 0;

   // se quitan los radio buttons
   rbtnSituacionEnemigo.Checked:= FALSE;
   rbtnLetalidad.Checked:= FALSE;
   rbtnCIADestino.Checked:= FALSE;
   rbtnCIAOrigen.Checked:= FALSE;

   grbxUnidadesBatalla.Enabled:= TRUE;
   grbxUnidadesBatalla.Font.Color:= clBlack;
   ColorTipoCelda:= CeldaMuestra.Brush.Color;

   lblLetalidad.Caption:= '[ ]';
end;

// --------------------------------------------------------------

procedure TfrmMapaCHAC.rbtnCeldaBosqueClick(Sender: TObject);
var
   pos: TPoint;

begin
   // Verde Normal
   CeldaMuestra.Brush.Color:= COLBOSQ_AL0;
   CeldaMuestra.Brush.Style:= bsSolid;
   CeldaMuestra.Shape:= stRectangle;

   CeldaMuestra.Pen.Color:= clGray;
   CeldaMuestra.Pen.Width:= 1;

   // se dibuja el hexgono de muestra
   pos.X:= 1;
   pos.Y:= 1;

   // se refresca automticamente para que se vea
   HexaMuestra.Pinta1Hex(CeldaMuestra.Brush.Color,bsSolid,pos,psSolid,
                         CeldaMuestra.Pen.Color,CeldaMuestra.Pen.Width,TRUE,TRUE);

   // altura media
   trAltura.Enabled:= TRUE;
   lblAltura.Enabled:= TRUE;
   trAltura.Position:= 0;

   // se quitan los radio buttons
   rbtnSituacionEnemigo.Checked:= FALSE;
   rbtnLetalidad.Checked:= FALSE;
   rbtnCIADestino.Checked:= FALSE;
   rbtnCIAOrigen.Checked:= FALSE;

   grbxUnidadesBatalla.Enabled:= TRUE;
   grbxUnidadesBatalla.Font.Color:= clBlack;
   ColorTipoCelda:= CeldaMuestra.Brush.Color;

   lblLetalidad.Caption:= '[ ]';
end;

// --------------------------------------------------------------

procedure TfrmMapaCHAC.rbtnCeldaOBSTACULOClick(Sender: TObject);
var
   pos: TPoint;

begin
   // Negro
   CeldaMuestra.Brush.Color:= COLOBSTACULO;
   CeldaMuestra.Brush.Style:= bsSolid;
   CeldaMuestra.Shape:= stRectangle;

   CeldaMuestra.Pen.Color:= clGray;
   CeldaMuestra.Pen.Width:= 1;

   // se dibuja el hexgono de muestra
   pos.X:= 1;
   pos.Y:= 1;

   // se refresca automticamente para que se vea
   HexaMuestra.Pinta1Hex(CeldaMuestra.Brush.Color,bsSolid,pos,psSolid,
                         CeldaMuestra.Pen.Color,CeldaMuestra.Pen.Width,TRUE,TRUE);

   // sin altura
   trAltura.Enabled:= FALSE;
   lblAltura.Enabled:= FALSE;
   trAltura.Position:=0;

   // se quitan los radio buttons
   rbtnSituacionEnemigo.Checked:= FALSE;
   rbtnLetalidad.Checked:= FALSE;
   rbtnCIADestino.Checked:= FALSE;
   rbtnCIAOrigen.Checked:= FALSE;

   grbxUnidadesBatalla.Enabled:= FALSE;
   grbxUnidadesBatalla.Font.Color:= clInactiveBorder;

   lblLetalidad.Caption:= '[ ]';
end;

// --------------------------------------------------------------

procedure TfrmMapaCHAC.rbtnSituacionEnemigoClick(Sender: TObject);
var
   pos: TPoint;

begin
   // Color del Tipo de Celda que sea
   CeldaMuestra.Brush.Color:= ColorTipoCelda;
   // forma cuadrado con borde rojo
   CeldaMuestra.Brush.Style:= bsSolid;
   CeldaMuestra.Shape:= stRectangle;

   CeldaMuestra.Pen.Color:= clRed;
   CeldaMuestra.Pen.Width:= 4;

   // se dibuja el hexgono de muestra
   pos.X:= 1;
   pos.Y:= 1;

   // se refresca automticamente para que se vea
   HexaMuestra.Pinta1Hex(CeldaMuestra.Brush.Color,bsSolid,pos,psSolid,
                         CeldaMuestra.Pen.Color,CeldaMuestra.Pen.Width,TRUE,TRUE);


   lblLetalidad.Caption:= '[ ]';

   // si hay que marcar la zona de ataque, se pone como direccin del frente el SUR
   if (chkMarcarzonaAtaque.Checked=TRUE) then
      rbtn_dir_S.Checked:= TRUE;

end;

// --------------------------------------------------------------

procedure TfrmMapaCHAC.rbtnLetalidadClick(Sender: TObject);

var
  danioInt: integer;

  pos: TPoint;

begin

   danioInt:= trLetalidad.Position;

   // Rojo
   // habr unos colores en funcin del impacto del arma
   if ((trLetalidad.Position>0) and (trLetalidad.Position<=DANIO_NIVEL_1)) then
        CeldaMuestra.Brush.Color:= COLDANIO_N1_25      // 25% de dao
   else if ((trLetalidad.Position>DANIO_NIVEL_1) and (trLetalidad.Position<=DANIO_NIVEL_2)) then
        CeldaMuestra.Brush.Color:= COLDANIO_N25_50      // 50% de dao
   else if ((trLetalidad.Position>DANIO_NIVEL_2) and (trLetalidad.Position<=DANIO_NIVEL_3)) then
        CeldaMuestra.Brush.Color:= COLDANIO_N50_75      // 75% de dao
   else if ((trLetalidad.Position>DANIO_NIVEL_3) and (trLetalidad.Position<=DANIO_NIVEL_4)) then
        CeldaMuestra.Brush.Color:= COLDANIO_N75_100;     // 100% de dao

   lblLetalidad.Caption:= '[' + IntToStr(danioInt) + ']';

   CeldaMuestra.Brush.Style:= bsSolid;
   CeldaMuestra.Shape:= stRectangle;

   CeldaMuestra.Pen.Color:= clGray;
   CeldaMuestra.Pen.Width:= 1;

   // se dibuja el hexgono de muestra
   pos.X:= 1;
   pos.Y:= 1;

   // se refresca automticamente para que se vea
   HexaMuestra.Pinta1Hex(CeldaMuestra.Brush.Color,bsSolid,pos,psSolid,
                         CeldaMuestra.Pen.Color,CeldaMuestra.Pen.Width,TRUE,TRUE);

end;

// --------------------------------------------------------------

procedure TfrmMapaCHAC.rbtnCIAOrigenClick(Sender: TObject);
var
   pos: TPoint;

begin
   // Color del Tipo de Celda que sea
   CeldaMuestra.Brush.Color:= ColorTipoCelda;
   // crculo con borde negro
   CeldaMuestra.Brush.Style:= bsSolid;
   CeldaMuestra.Shape:= stCircle;
   CeldaMuestra.Pen.Color:= clBlack;
   CeldaMuestra.Pen.Width:= 4;

   // se dibuja el hexgono de muestra
   pos.X:= 1;
   pos.Y:= 1;

   // se refresca automticamente para que se vea
   HexaMuestra.Pinta1Hex(CeldaMuestra.Brush.Color,bsSolid,pos,psSolid,
                         CeldaMuestra.Pen.Color,CeldaMuestra.Pen.Width,TRUE,TRUE);

   lblLetalidad.Caption:= '[ ]';
end;

// --------------------------------------------------------------

procedure TfrmMapaCHAC.rbtnCIADestinoClick(Sender: TObject);
var
   pos: TPoint;

begin
   // Color del Tipo de Celda que sea
   CeldaMuestra.Brush.Color:= ColorTipoCelda;
   // crculo con borde amarillo
   CeldaMuestra.Brush.Style:= bsSolid;
   CeldaMuestra.Shape:= stCircle;
   CeldaMuestra.Pen.Color:= clYellow;
   CeldaMuestra.Pen.Width:= 4;

   // se dibuja el hexgono de muestra
   pos.X:= 1;
   pos.Y:= 1;

   // se refresca automticamente para que se vea
   HexaMuestra.Pinta1Hex(CeldaMuestra.Brush.Color,bsSolid,pos,psSolid,
                         CeldaMuestra.Pen.Color,CeldaMuestra.Pen.Width,TRUE,TRUE);

   lblLetalidad.Caption:= '[ ]';
end;

// --------------------------------------------------------------

procedure TfrmMapaCHAC.btnLimpiarMapaClick(Sender: TObject);
begin
   // en modo info no se dibuja nada
   if (chkModoInfo.Checked=TRUE) then begin
     ShowMessage ('Info Mode. The Map cannot be edited');
     exit;
   end;

   LimpiarMapa();
end;

// --------------------------------------------------------------

procedure TfrmMapaCHAC.btnTodoMapaIgualClick(Sender: TObject);
var
   i,j: integer;

   pos: TPoint;

begin

  // en modo info no se dibuja nada
  if (chkModoInfo.Checked=TRUE) then begin
     ShowMessage ('Info Mode. The Map cannot be edited');
     exit;
  end;

  // si se quieren poner celdas de tipo Origen o Destino, no se hace
  if (rbtnCIAOrigen.Checked=TRUE)then begin
     ShowMessage ('Just an Origin cell can be defined');
     exit;
  end;
  if (rbtnCIADestino.Checked=TRUE)then begin
     ShowMessage ('Just a Destination cell can be defined');
     exit;
  end;

  // creamos las celdas del mapa
  for i:= 0 to (NFILS_MAPA-1) do begin
     for j:= 0 to (NCOLS_MAPA-1) do begin

        pos.x:= j+1;  // x <=> columna
        pos.y:= i+1;  // y <=> fila

        // si est la imagen de fondo no se sobreescribe
        if (frmMapaCHAC.chkVerImagen.Checked=TRUE) then
           // no se refresca cada vez para evitar parpadeos
           MapaHEX.Pinta1Hex(CeldaMuestra.Brush.Color,bsSolid,pos,psSolid,
                             CeldaMuestra.Pen.Color,CeldaMuestra.Pen.Width,FALSE,FALSE)
        else
           // no se refresca cada vez para evitar parpadeos
           MapaHEX.Pinta1Hex(CeldaMuestra.Brush.Color,bsSolid,pos,psSolid,
                             CeldaMuestra.Pen.Color,CeldaMuestra.Pen.Width,TRUE,FALSE);

// @@@
// @@@
// @@@

        // guardamos los datos para simulacin de las celdas
        GuardarDatosCelda(i,j);
     end;
  end;

  // una vez dibujado todo, se hace el refresco para dibujar el mapa sin parpadeo
  frmMapaCHAC.MapaHEX.Refrescar;

end;

// --------------------------------------------------------------

procedure TfrmMapaCHAC.trAlturaChange(Sender: TObject);
var
   pos: TPoint;

begin

  // cada celda tendr unos colores en funcin de la altura
  case trAltura.Position of
    3: if (rbtnCeldaNormal.Checked=TRUE) then CeldaMuestra.Brush.Color:= COLNORM_AL3
       else if (rbtnCeldaAgua.Checked=TRUE) then CeldaMuestra.Brush.Color:= COLAGUA_AL3
       else if (rbtnCeldaBosque.Checked=TRUE) then CeldaMuestra.Brush.Color:= COLBOSQ_AL3;
    2: if (rbtnCeldaNormal.Checked=TRUE) then CeldaMuestra.Brush.Color:= COLNORM_AL2
         else if (rbtnCeldaAgua.Checked=TRUE) then CeldaMuestra.Brush.Color:= COLAGUA_AL2
         else if (rbtnCeldaBosque.Checked=TRUE) then CeldaMuestra.Brush.Color:= COLBOSQ_AL2;
    1: if (rbtnCeldaNormal.Checked=TRUE) then CeldaMuestra.Brush.Color:= COLNORM_AL1
         else if (rbtnCeldaAgua.Checked=TRUE) then CeldaMuestra.Brush.Color:= COLAGUA_AL1
         else if (rbtnCeldaBosque.Checked=TRUE) then CeldaMuestra.Brush.Color:= COLBOSQ_AL1;
    0: if (rbtnCeldaNormal.Checked=TRUE) then CeldaMuestra.Brush.Color:= COLNORM_AL0
       else if (rbtnCeldaAgua.Checked=TRUE) then CeldaMuestra.Brush.Color:= COLAGUA_AL0
       else if (rbtnCeldaBosque.Checked=TRUE) then CeldaMuestra.Brush.Color:= COLBOSQ_AL0;
    -1: if (rbtnCeldaNormal.Checked=TRUE) then CeldaMuestra.Brush.Color:= COLNORM_AL_1
           else if (rbtnCeldaAgua.Checked=TRUE) then CeldaMuestra.Brush.Color:= COLAGUA_AL_1
           else if (rbtnCeldaBosque.Checked=TRUE) then CeldaMuestra.Brush.Color:= COLBOSQ_AL_1;
    -2: if (rbtnCeldaNormal.Checked=TRUE) then CeldaMuestra.Brush.Color:= COLNORM_AL_2
           else if (rbtnCeldaAgua.Checked=TRUE) then CeldaMuestra.Brush.Color:= COLAGUA_AL_2
           else if (rbtnCeldaBosque.Checked=TRUE) then CeldaMuestra.Brush.Color:= COLBOSQ_AL_2;
    -3: if (rbtnCeldaNormal.Checked=TRUE) then CeldaMuestra.Brush.Color:= COLNORM_AL_3
        else if (rbtnCeldaAgua.Checked=TRUE) then CeldaMuestra.Brush.Color:= COLAGUA_AL_3
        else if (rbtnCeldaBosque.Checked=TRUE) then CeldaMuestra.Brush.Color:= COLBOSQ_AL_3;
  end;

  lblValAltura.Caption:= '[' + inttostr(-trAltura.Position) + ']';

  ColorTipoCelda:= CeldaMuestra.Brush.Color;

  // se dibuja el hexgono de muestra
  pos.X:= 1;
  pos.Y:= 1;

  // se refresca para que se vea la muestra
  HexaMuestra.Pinta1Hex(CeldaMuestra.Brush.Color,bsSolid,pos,psSolid,
                        CeldaMuestra.Pen.Color,CeldaMuestra.Pen.Width,TRUE,TRUE);

end;

// --------------------------------------------------------------

procedure TfrmMapaCHAC.trLetalidadChange(Sender: TObject);

var
   danioInt: integer;

   pos: TPoint;

begin

   if (rbtnLetalidad.Checked=TRUE) then begin

      danioInt:= trLetalidad.Position;

      // Rojo
      // habr unos colores en funcin del impacto del arma
      if ((trLetalidad.Position>0) and (trLetalidad.Position<=DANIO_NIVEL_1)) then
          CeldaMuestra.Brush.Color:= COLDANIO_N1_25      // 25% de dao
      else if ((trLetalidad.Position>DANIO_NIVEL_1) and (trLetalidad.Position<=DANIO_NIVEL_2)) then
          CeldaMuestra.Brush.Color:= COLDANIO_N25_50      // 50% de dao
      else if ((trLetalidad.Position>DANIO_NIVEL_2) and (trLetalidad.Position<=DANIO_NIVEL_3)) then
          CeldaMuestra.Brush.Color:= COLDANIO_N50_75      // 75% de dao
      else if ((trLetalidad.Position>DANIO_NIVEL_3) and (trLetalidad.Position<=DANIO_NIVEL_4)) then
          CeldaMuestra.Brush.Color:= COLDANIO_N75_100;     // 100% de dao

      lblLetalidad.Caption:= '[' + IntToStr(danioInt) + ']';

      // se dibuja el hexgono de muestra
      pos.X:= 1;
      pos.Y:= 1;

      // se refresca para que se vea la muestra
      HexaMuestra.Pinta1Hex(CeldaMuestra.Brush.Color,bsSolid,pos,psSolid,
                            CeldaMuestra.Pen.Color,CeldaMuestra.Pen.Width,TRUE,TRUE);

   end;

end;

// --------------------------------------------------------------

procedure TfrmMapaCHAC.btnRedimensionarMapaClick(Sender: TObject);
var
   fils_ant, cols_ant: integer;
   hayquecrear: boolean;

begin

  hayquecrear:= TRUE;

  // damos valor a las variables de tamao y nmero de celdas en funcin
  // de los radiobutton marcados
  if (rbtn10x10.Checked=TRUE) then begin
     fils_ant:= NFILS_MAPA;
     cols_ant:= NCOLS_MAPA;
     NFILS_MAPA:= 10;
     NCOLS_MAPA:= 10;
     RADIO_CELDA:= 34;

     if (fils_ant=NFILS_MAPA) and (cols_ant=NCOLS_MAPA) then hayquecrear:=FALSE;
  end
  else if (rbtn15x15.Checked=TRUE) then begin
     fils_ant:= NFILS_MAPA;
     cols_ant:= NCOLS_MAPA;
     NFILS_MAPA:= 15;
     NCOLS_MAPA:= 15;
     RADIO_CELDA:= 22;

     if (fils_ant=NFILS_MAPA) and (cols_ant=NCOLS_MAPA) then hayquecrear:=FALSE;
  end
  else if (rbtn30x30.Checked=TRUE) then begin
     fils_ant:= NFILS_MAPA;
     cols_ant:= NCOLS_MAPA;
     NFILS_MAPA:= 30;
     NCOLS_MAPA:= 30;
     RADIO_CELDA:= 12;

     if (fils_ant=NFILS_MAPA) and (cols_ant=NCOLS_MAPA) then hayquecrear:=FALSE;
  end
  else if (rbtn45x45.Checked=TRUE) then begin
     fils_ant:= NFILS_MAPA;
     cols_ant:= NCOLS_MAPA;
     NFILS_MAPA:= 45;
     NCOLS_MAPA:= 45;
     RADIO_CELDA:= 8;

     if (fils_ant=NFILS_MAPA) and (cols_ant=NCOLS_MAPA) then hayquecrear:=FALSE;
  end;

// @@@ siempre se crea el mapa porque no funciona 'Limpiar' en este componente
// @@@  if (hayquecrear=TRUE) then
// @@@     // Creamos el Mapa con los valores completados anteriormente
     CrearMapa(PanelMapa,fils_ant,cols_ant);
// @@@  else
// @@@     // Si no hay que crearlo (el mismo tamao), solo se limpia
// @@@     LimpiarMapa();

  // @@@ Informamos de las dimensiones del mapa
  frmMapaCHAC.txtInfoDimensiones.Text:= ' ' + IntToStr(NFILS_MAPA) + ' Rows x '
                                            + IntToStr(NCOLS_MAPA) + ' Cols | Rad = '
                                            + IntToStr(RADIO_CELDA);

end;

// --------------------------------------------------------------

procedure TfrmMapaCHAC.btnCargarMapaClick(Sender: TObject);
begin

   dlgAbrirMapa.InitialDir := GetCurrentDir;

   // Se muestra el Dilogo para Abrir el Fichero del Mapa
  if dlgAbrirMapa.Execute then begin
     CargarMapa(dlgAbrirMapa.FileName);
     showmessage('Map Loaded Correctly');
  end;

end;

// --------------------------------------------------------------

procedure TfrmMapaCHAC.btnGuardarMapaClick(Sender: TObject);
begin

   dlgGuardarMapa.InitialDir := GetCurrentDir;

   // Se muestra el Dilogo para Abrir el Fichero del Mapa
  if dlgGuardarMapa.Execute then
     GuardarMapa(dlgGuardarMapa.FileName);

end;

// --------------------------------------------------------------

procedure TfrmMapaCHAC.chkModoInfoClick(Sender: TObject);
begin
   txtInfoCelda.Text:= ' ';

   if (chkModoInfo.Checked=TRUE) then
      frmMapaCHAC.PanelMapa.Cursor:= crHelp
   else
      frmMapaCHAC.PanelMapa.Cursor:= crDrag;

end;

// --------------------------------------------------------------

procedure TfrmMapaCHAC.btnSalirClick(Sender: TObject);
begin
  Close;
end;

// --------------------------------------------------------------

procedure TfrmMapaCHAC.btnCargarSolucionesClick(Sender: TObject);
begin

  dlgAbrirSoluciones.InitialDir:= GetCurrentDir;

  // Se muestra el Dilogo para Abrir el Fichero del Mapa
  if dlgAbrirSoluciones.Execute then begin

     soluciones_cargadas:= FALSE;
     btnMostrarSolucion.Enabled:= FALSE;

     // se cargan las soluciones del fichero en la variable
     CargarSoluciones(dlgAbrirSoluciones.FileName);

     // se muestran las soluciones en la lista
     MostrarListaSoluciones();

     soluciones_cargadas:= TRUE;
     btnMostrarSolucion.Enabled:= TRUE;

     // mostramos los detalles de la primera
     sgSolucionesClick(Self);

     // buscamos los enemigos
     BuscarEnemigos();

     num_sols_mostradas:= 0;

  end;

end;

// --------------------------------------------------------------

procedure TfrmMapaCHAC.sgSolucionesClick(Sender: TObject);

var
  ind_sol,fila,j,max: integer;
  cad_aux: string;

  rec_cam, sal_cam: real;

begin

   if (soluciones_cargadas=TRUE) then begin

      // ndice de la solucin a detallar
      fila:= sgSoluciones.Row;
      cad_aux:= sgSoluciones.Cells[0,fila];
      ind_sol:= StrToInt(cad_aux);

      // se limpian los items
      lbDetalleSoluciones.Items.Clear;

      cad_aux:= 'SOLUTION ' + sgSoluciones.Cells[0,fila];
      lbDetalleSoluciones.Items.Append(cad_aux);
      cad_aux:= '--------------------------------------------------------------------';
      lbDetalleSoluciones.Items.Append(cad_aux);

      // Insertamos el consumo de recursos y de salud
      rec_cam:= consumo_recursos_camino(Sols_FP.soluciones_FP[ind_sol].camino,
                                        low(Sols_FP.soluciones_FP[ind_sol].camino),
                                        high(Sols_FP.soluciones_FP[ind_sol].camino));
      cad_aux:= '[ resources: ' + FloatToStrF(rec_cam,ffGeneral,7,20);
      sal_cam:= consumo_salud_camino(Sols_FP.soluciones_FP[ind_sol].camino,
                                     low(Sols_FP.soluciones_FP[ind_sol].camino),
                                     high(Sols_FP.soluciones_FP[ind_sol].camino));
      cad_aux:= cad_aux + '  |  health: ' + FloatToStrF(sal_cam,ffGeneral,7,20) + ' ]';
      lbDetalleSoluciones.Items.Append(cad_aux);
      cad_aux:= '--------------------------------------------------------------------';
      lbDetalleSoluciones.Items.Append(cad_aux);

      max:= high(Sols_FP.soluciones_FP[ind_sol].camino);

      // se recorre la solucin y se muestra el camino en el listbox
      for j:=0 to max do begin

         // coordenadas y altura
         cad_aux:= '[' + intToStr(Sols_FP.soluciones_FP[ind_sol].camino[j].x) +
                   ',' + intToStr(Sols_FP.soluciones_FP[ind_sol].camino[j].y) + '],  hgt= ' +
                   intToStr(Sols_FP.soluciones_FP[ind_sol].camino[j].altura) + ', ';

         // tipo
         if (Sols_FP.soluciones_FP[ind_sol].camino[j].tipo = NORM) then
            cad_aux:= cad_aux + 'NORMAL' + ', '
         else if (Sols_FP.soluciones_FP[ind_sol].camino[j].tipo = BOSQ) then
            cad_aux:= cad_aux + 'FOREST' + ', '
         else if (Sols_FP.soluciones_FP[ind_sol].camino[j].tipo = AGUA) then
            cad_aux:= cad_aux + 'WATER' + ', ';

         // tipo especial
         if (Sols_FP.soluciones_FP[ind_sol].camino[j].tipo_esp = PORIGEN) then
            cad_aux:= cad_aux + 'UNIT ORIGIN'
         else if (Sols_FP.soluciones_FP[ind_sol].camino[j].tipo_esp = PDESTINO) then
            cad_aux:= cad_aux + 'TARGET POINT';

         lbDetalleSoluciones.Items.Append(cad_aux);

      end;

   end;

end;

// --------------------------------------------------------------

procedure TfrmMapaCHAC.btnMostrarSolucionClick(Sender: TObject);

var
  i,j,max,ind_sol,fila: integer;
  celda_od: t_celda;
  VO: integer;

  pos: TPoint;

  celdadib: TDibCelda;

begin

   // comprobamos que estn las celdas Origen y Destino
   if (BuscarOrigenDestinoEnemigo('O',celda_od) = TRUE) and
      (BuscarOrigenDestinoEnemigo('D',celda_od) = TRUE) then begin

      // ----------------

      // se 'restauran' los nodos del camino que marca la solucin anterior
      // LimpiarSolucionAnterior();

      // ----------------

      // se apunta la solucin mostrada
      num_sols_mostradas:= num_sols_mostradas+1;

      // solucin seleccionada
      fila:= sgSoluciones.Row;
      ind_sol:= StrToInt(sgSoluciones.Cells[0,fila]);

      max:= high(Sols_FP.soluciones_FP[ind_sol].camino);

      // se recorren los nodos de la solucin y se marca el camino en el mapa
      for i:=1 to max-1 do begin
          pos.y:=Sols_FP.soluciones_FP[ind_sol].camino[i].y+1;
          pos.x:=Sols_FP.soluciones_FP[ind_sol].camino[i].x+1;

          // se obtienen los datos de dibujo de la celda en cuestin
          celdadib:= MapaHex.DatosDibHexa(pos.x,pos.y);

          celdadib.color_relleno:= clBlack;

          // cada solucin se muestra con un estilo de relleno
          case (num_sols_mostradas mod 4) of
            0: celdadib.estilo_relleno:= bsBDiagonal;
            1: celdadib.estilo_relleno:= bsVertical;
            2: celdadib.estilo_relleno:= bsHorizontal;
            3: celdadib.estilo_relleno:= bsFDiagonal;
          end;

          celdadib.color_borde:= clBlack;
          celdadib.grosor_borde:= 2;  // un poco ms ancho

          // si es oculta a todos los enemigos, se marca en rosa (si hay enemigos)
          if (num_enemigos > 0) then begin
             celdadib.color_borde:= clFuchsia;  // se cambia el color del borde
             celdadib.grosor_borde:= 2;
          end;

          for j:=0 to (num_enemigos-1) do begin

             // si es vista por alguno de ellos
             VO:= celda_VO(Sols_FP.soluciones_FP[ind_sol].camino[i],ENEMIGOS[j],DatosCeldas,(NCOLS_MAPA-1),(NFILS_MAPA-1));
             if (VO=1) then begin
               celdadib.color_borde:= clBlack;
               celdadib.grosor_borde:= 2;
               break;
             end;

          end;

         // si se est mostrando la imagen de fondo, se dibuja sobre ella
         if (chkVerImagen.Checked=TRUE) then begin
            MapaHEX.PintaBordeHex(pos,celdadib.color_borde,2,celdadib.color_borde,2,
                                  celdadib.color_borde,2,celdadib.color_borde,2,
                                  celdadib.color_borde,2,celdadib.color_borde,2,FALSE);
         end
         else
            // Pintamos el Hexgono (no se refresca automticamente)
            MapaHEX.Pinta1Hex(celdadib.color_relleno,celdadib.estilo_relleno,pos,
                              celdadib.estilo_borde,celdadib.color_borde,celdadib.grosor_borde,TRUE,FALSE);

      end;

      // una vez dibujado todo, se hace el refresco para dibujar el mapa sin parpadeo
      MapaHEX.Refrescar;

      // guardamos el ndice de la solucin actual (ser la anterior despus)
      sol_anterior:= ind_sol;


      // se activa el botn para borrar soluciones
      btnLimpiarSoluciones.Enabled:= TRUE;

   end
   else begin
      ShowMessage('A Map with an Origin and Destination must be Loaded');
   end;

end;

// --------------------------------------------------------------

procedure TfrmMapaCHAC.rbtn_dir_SClick(Sender: TObject);
var
   i,j: integer;

begin

  // damos valores a las variables que definen la zona de ataque
  // abajo <=> frente de ataque

  // reservamos memoria para la nueva plantilla
  Finalize(zona_ataque_enemigo);
  SetLength(zona_ataque_enemigo,NFILS_PLANT_ZA,NCOLS_PLANT_ZA);

  // copiamos la plantilla del frente SUR
  for i:=0 to (NFILS_PLANT_ZA-1) do begin
     for j:=0 to (NCOLS_PLANT_ZA-1) do begin

           zona_ataque_enemigo[i,j]:= zona_ataque_enemigo_S[i,j];

           // volvemos a apuntar la posicin del enemigo en la plantilla
           if (zona_ataque_enemigo[i,j].tipo_esp = ENEMIGO) then begin
              POS_PLANT_ENE_fil:= i;
              POS_PLANT_ENE_col:= j;
           end;

        end;
     end;


end;


// --------------------------------------------------------------

procedure TfrmMapaCHAC.rbtn_dir_NClick(Sender: TObject);
var
   i,j: integer;
   pos_i, pos_j: integer;

begin

  // damos valores a las variables que definen la zona de ataque
  // arriba <=> frente de ataque

  // reservamos memoria para la nueva plantilla
  Finalize(zona_ataque_enemigo);
  SetLength(zona_ataque_enemigo,NFILS_PLANT_ZA,NCOLS_PLANT_ZA);

  // transformamos la plantilla del frente SUR a frente NORTE
  for i:=0 to (NFILS_PLANT_ZA-1) do begin
     for j:=0 to (NCOLS_PLANT_ZA-1) do begin

        pos_i:= (NFILS_PLANT_ZA-1)-i;
        pos_j:= (NCOLS_PLANT_ZA-1)-j;
        zona_ataque_enemigo[pos_i,pos_j]:= zona_ataque_enemigo_S[i,j];

        // volvemos a apuntar la posicin del enemigo en la plantilla
        if (zona_ataque_enemigo[pos_i,pos_j].tipo_esp = ENEMIGO) then begin
           POS_PLANT_ENE_fil:= pos_i;
           POS_PLANT_ENE_col:= pos_j;
        end;

     end;
  end;

end;

// --------------------------------------------------------------

procedure TfrmMapaCHAC.chkMarcarZonaAtaqueClick(Sender: TObject);
begin

  // la direccin del frente del enemigo solo ser importante
  // si se va a marcar la zona de ataque de manera automtica
  if (chkMarcarZonaAtaque.Checked=TRUE) then begin

      // leemos la plantilla de zona de impacto de armas de enemigo

      // se pide al usuario la plantilla con los datos
      // (fichero de tipo mapa con la plantilla a dibujar)
      dlgAbrirMapa.InitialDir := GetCurrentDir;
      dlgAbrirMapa.Title:= 'Select a Template Attack Zone File (South Front) to Load';

      // Se muestra el Dilogo para Abrir el Fichero de la Plantilla (Tipo Mapa)
      if dlgAbrirMapa.Execute then begin
         grbxDireccionEnemigo.Enabled:= TRUE;
         CargarZonaAtaqueEnemigo(dlgAbrirMapa.FileName);
      end;

  end
  else
      grbxDireccionEnemigo.Enabled:= FALSE;

  // se deja el ttulo de carga de mapas como estaba
  dlgAbrirMapa.Title:= 'Select a Map File to Load';

end;

// --------------------------------------------------------------
// @@@

procedure TfrmMapaCHAC.chkVerImagenClick(Sender: TObject);
var
  i,j: integer;
  nfils_ant, ncols_ant: integer;
  pos: TPoint;

begin

   if (MapaHex.MapImageName='') then exit;

   if (chkVerImagen.Checked=TRUE) then begin
      MapaHex.NoMapImage:= FALSE;

      // es posible que se redimensione el mapa
      nfils_ant:= NFILS_MAPA;
      ncols_ant:= NCOLS_MAPA;

      NFILS_MAPA:= MapaHex.HexRows;
      NCOLS_MAPA:= MapaHex.HexColumns;
      RADIO_CELDA:= MapaHex.HexRadius;

      if (nfils_ant <> NFILS_MAPA) or (ncols_ant <> NCOLS_MAPA) then begin

         // se redimensiona la matriz de datos de las celdas
         SetLength(DatosCeldas,NFILS_MAPA,NCOLS_MAPA);

         // se inicializan los nuevos elementos

         // nueva/s fila/s
         if (nfils_ant <> NFILS_MAPA) then begin
            for i:=nfils_ant to (NFILS_MAPA-1) do begin
               for j:=0 to (NCOLS_MAPA-1) do begin
                  DatosCeldas[i,j].altura:= ALT_VACIA;
               end;
            end;
         end;

         // nueva/s columna/s
         if (ncols_ant <> NCOLS_MAPA) then begin
            for i:=0 to (NFILS_MAPA-1) do begin
               for j:=ncols_ant to (NCOLS_MAPA-1) do begin
                  DatosCeldas[i,j].altura:= ALT_VACIA;
               end;
            end;
         end;

      end;

      // Informamos de las dimensiones del mapa
      frmMapaCHAC.txtInfoDimensiones.Text:= ' ' + IntToStr(NFILS_MAPA) + ' Rows x '
                                                + IntToStr(NCOLS_MAPA) + ' Cols | Rad = '
                                                + IntToStr(RADIO_CELDA);

     // @@@ se redibujan las celdas de origen, destino y enemigos para
     // @@@ que se vea bien el borde
     for i:= 0 to (NFILS_MAPA-1) do begin
        for j:= 0 to (NCOLS_MAPA-1) do begin
           pos.x:= j+1;
           pos.y:= i+1;
           if (DatosCeldas[i,j].tipo_esp=ENEMIGO) then begin
               MapaHEX.PintaBordeHex(pos,clRed,3,clRed,3,clRed,3,clRed,3,clRed,3,clRed,3,FALSE);
           end
           else if (DatosCeldas[i,j].tipo_esp=PORIGEN) then begin
               MapaHEX.PintaBordeHex(pos,clBlack,3,clBlack,3,clBlack,3,clBlack,3,clBlack,3,clBlack,3,FALSE);
           end
           else if (DatosCeldas[i,j].tipo_esp=PDESTINO) then begin
               MapaHEX.PintaBordeHex(pos,clYellow,3,clYellow,3,clYellow,3,clYellow,3,clYellow,3,clYellow,3,FALSE);
           end;
        end;
     end;

   end
   else begin
      MapaHex.NoMapImage:= TRUE;

      // Se Redibujan los Hexagonos (se pierden al actualizar la imagen)
      for i:= 0 to (NFILS_MAPA-1) do begin
         for j:= 0 to (NCOLS_MAPA-1) do begin
            DibujarCelda(DatosCeldas[i,j]);
         end;
      end;

     // @@@ se redibujan las celdas de origen, destino y enemigos para
     // @@@ que se vea bien el borde
     for i:= 0 to (NFILS_MAPA-1) do begin
        for j:= 0 to (NCOLS_MAPA-1) do begin

           if (DatosCeldas[i,j].tipo_esp=ENEMIGO) or
              (DatosCeldas[i,j].tipo_esp=PORIGEN) or
              (DatosCeldas[i,j].tipo_esp=PDESTINO) then begin
              DibujarCelda(DatosCeldas[i,j]);
           end;

        end;
     end;

   end;

  // una vez dibujado todo, se hace el refresco para dibujar el mapa sin parpadeo
  frmMapaCHAC.MapaHEX.Refrescar;

end;

// --------------------------------------------------------------

procedure TfrmMapaCHAC.btnImagenFondoClick(Sender: TObject);
begin

  dlgAbrirImagen.InitialDir := GetCurrentDir;

   // Se muestra el Dilogo para Abrir el Fichero de Imagen de Fondo
  if dlgAbrirImagen.Execute then begin
      MapaHEX.MapImageName:= ExtractFileName(dlgAbrirImagen.FileName);
      edImagenFondo.Text:= ExtractFileName(dlgAbrirImagen.FileName);
      chkVerImagen.Checked:= FALSE;
  end;

end;

// --------------------------------------------------------------

procedure TfrmMapaCHAC.btnLimpiarSolucionesClick(Sender: TObject);
begin
   btnLimpiarSoluciones.Enabled:= FALSE;

   if (num_sols_mostradas > 0) then
      LimpiarMarcasMapa();

   num_sols_mostradas:= 0;

end;

// --------------------------------------------------------------


///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
//                           UTILIDADES                                      //
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////

procedure TfrmMapaCHAC.btnVisibilidadClick(Sender: TObject);
var
   i,j: integer;
   celdai, celdaf: t_celda;

   esta_orig, esta_dest: boolean;
   VO: integer;

begin

  esta_orig:= false;
  esta_dest:= false;

  // buscamos las celdas ORIGEN y DESTINO en el mapa
  for i:= 0 to (NFILS_MAPA-1) do begin

     if (esta_orig = true) and (esta_dest = true) then break;

     for j:= 0 to (NCOLS_MAPA-1) do begin

        if (esta_orig = true) and (esta_dest = true) then break;

        if (DatosCeldas[i,j].tipo_esp = PORIGEN) then begin
            celdai:= DatosCeldas[i,j];
            esta_orig:= true;
            continue;
        end;

        if (DatosCeldas[i,j].tipo_esp = PDESTINO) then begin
            celdaf:= DatosCeldas[i,j];
            esta_dest:= true;
            continue;
        end;

     end;  // for j

  end;  // for i


  if (esta_orig = true) and (esta_dest = true) then begin
      // llamamos a la funcin de la lnea de visin
      VO:= celda_VO(celdai,celdaf,DatosCeldas,(NCOLS_MAPA-1),(NFILS_MAPA-1));

      if VO = 1 then showmessage('Visible Cell')
      else showmessage('Hidden Cell');
  end
  else
      showmessage('You must define an Origin and Destination cells');

end;

// --------------------------------------------------------------

(*
   Procedimiento que determina si una celda (nodo) es vista u oculta desde las celdas (nodos)
   que la rodean en un radio determinado y calcula una media de vistas y ocultas
   como funcin heurstica.
   Se mira en un cuadro de lado (2*radio)+1 centrado en nodoi
   Recibe como parmetros:
      - nodoi -> nodo inicial
      - radio_VO -> radio en el que se mirar
   Devuelve:
      - val_V -> media de celdas vistas
      - val_O -> media de celdas ocultas
*)
procedure calcula_valor_zona_VO (nodoi: t_celda; radio_VO: integer; var val_V:real; var val_O: real);

var
  i,j: integer;

  min_fil, max_fil, min_col, max_col: integer;  //lmites a mirar

  VO: byte;  // indicador de celda vista (1) u oculta (0)
  cont, cont_v, cont_o: integer;

begin

   // obtenemos los lmites a mirar
   min_fil:= nodoi.y - radio_VO;
   if (min_fil < 0) then min_fil:= 0;

   max_fil:= nodoi.y + radio_VO;
   if (max_fil >= (NFILS_MAPA-1)) then max_fil:= (NFILS_MAPA-1);

   min_col:= nodoi.x - radio_VO;
   if (min_col < 0) then min_col:= 0;

   max_col:= nodoi.x + radio_VO;
   if (max_col >= (NCOLS_MAPA-1)) then max_col:= (NCOLS_MAPA-1);

   // inicializamos los contadores
   cont_v:= 0;
   cont_o:= 0;
   cont:= 0;

   // comprobamos la visibilidad de la celda desde cada uno de los puntos del
   // cuadrado que la contiene, centrado en ella
   for i:= min_fil to max_fil do begin

      for j:= min_col to max_col do begin

         // comprobamos la visibilidad desde todas las celdas, menos desde la deseada
         if (DatosCeldas[i,j].x <> nodoi.x) or (DatosCeldas[i,j].y <> nodoi.y) then begin

            // comprobamos si la celda es vista u oculta
            VO:= celda_VO(nodoi,DatosCeldas[i,j],DatosCeldas,max_col,max_fil);

            if (VO = 1) then
               cont_v:= cont_v + 1    // es vista
            else
               cont_o:= cont_o + 1;   // es oculta

            // contador del celdas comprobadas
            cont:= cont + 1;

         end;

      end;

   end;

   // calculamos las medias de vistas y ocultas
   val_v:= cont_v/cont;
   val_o:= cont_o/cont;

end;

// --------------------------------------------------------------

procedure TfrmMapaCHAC.btnVisibilidadZonaClick(Sender: TObject);

var
   i,j: integer;
   fin: boolean;
   celdaz: t_celda;

   vv,vo: real;

begin

  fin:= false;

  // buscamos la celda ORIGEN
  for i:= 0 to (NFILS_MAPA-1) do begin

     if (fin = true) then break;

     for j:= 0 to (NCOLS_MAPA-1) do begin

        if (DatosCeldas[i,j].tipo_esp = PORIGEN) then begin
           celdaz:= DatosCeldas[i,j];
           fin:= true;
           break;
        end;

     end;  // for j

  end;  // for i

  calcula_valor_zona_VO(celdaz,2,vv,vo);

  ShowMessage('Visible Average: ' + FloatToStr(vv) +
              '  Hidden Average: ' + FloatToStr(vo));


end;

// --------------------------------------------------------------

procedure TfrmMapaCHAC.btnActualizarValoresMapaClick(Sender: TObject);

var
   i,j: integer;

begin

  // se actualizan los valores de dao y recursos por defecto en el mapa
  // cargado actualmente
  for i:= 0 to (NFILS_MAPA-1) do begin
     for j:= 0 to (NCOLS_MAPA-1) do begin
        if (DatosCeldas[i,j].tipo=NORM) then begin
           DatosCeldas[i,j].danio_0:=DANIO_0_NORM;
           DatosCeldas[i,j].recursos_0:=RECURSOS_0_NORM;
        end
        else if (DatosCeldas[i,j].tipo=BOSQ) then begin
           DatosCeldas[i,j].danio_0:=DANIO_0_BOSQ;
           DatosCeldas[i,j].recursos_0:=RECURSOS_0_BOSQ;
        end
        else if (DatosCeldas[i,j].tipo=AGUA) then begin
           DatosCeldas[i,j].danio_0:=DANIO_0_AGUA;
           DatosCeldas[i,j].recursos_0:=RECURSOS_0_AGUA;
        end;
     end;
  end;

  showmessage('Map Updated');

end;

// --------------------------------------------------------------

procedure TfrmMapaCHAC.btnEscogerMejoresSolucionesClick(Sender: TObject);

var
  i: integer;
  fichero_soluciones, fichero_minimos, extension: string;

  bl: string;

begin

     bl:= '';
     fichero_minimos:= edFicheroSoluciones.Text + ' (' +edRSel.text + edrs.text + ').min';

     for i:=1 to 30 do begin

          // se actualiza el nombre del fichero de soluciones
          extension:= ' [' + edRSel.Text + bl + ',s' + IntToStr(i) + ',' +
                      edNumIT.Text + 'it,' + edNumH.Text + 'h,' + edrs.Text + ']'+ '.sol';
          fichero_soluciones:=  edFicheroSoluciones.Text + extension;

          BuscarMinimos(fichero_soluciones, edrs.Text, fichero_minimos);

     end;

     showmessage('Yast');

end;

// --------------------------------------------------------------

procedure TfrmMapaCHAC.btnMarcarVOEnemigosClick(Sender: TObject);

begin

  // buscamos los enemigos en el mapa
  BuscarEnemigos();

  if (num_enemigos=0) then begin
     showmessage('There is no Enemy in the Map');
     exit;
  end;

  pintar_VO_zona_ca();

  Showmessage('Hidden Cells (to all enemies) marked. Adquisition Distance = ' +
              intToStr(CAP_ADQ_ENE) + ' cells');


end;

// --------------------------------------------------------------

procedure TfrmMapaCHAC.btnMarcarObstaculosNatClick(Sender: TObject);
var
   i,j,k,l: integer;

   fil_vec, col_vec: integer;  // ndices del nodo vecino
   num_vec: integer;

   pos: TPoint;

begin

  // recorremos las celdas y para cada una miramos sus vecinos
  for i:=0 to (NFILS_MAPA-1) do begin
    for j:=0 to (NCOLS_MAPA-1) do begin
      for k:=0 to (N_VECINOS_FIL-1) do begin
        for l:=0 to (N_VECINOS_COL-1) do begin

            // Fila
            fil_vec:= i + k - 1;
            // Columna
            col_vec:= j + l - 1;

            // si es el mismo nodo, no se comprueba
            if (fil_vec = i) and (col_vec = j) then begin
               continue;
            end;

            // si se sale de los lmites del tablero, se pasa al siguiente
            if ((fil_vec < 0) or (fil_vec >= NFILS_MAPA)) or
               ((col_vec < 0) or (col_vec >= NCOLS_MAPA)) then begin
               continue;
            end;

            // si es la celda que ocupa un enemigo alguno de ellos, se termina
            if (DatosCeldas[i,j].tipo_esp = ENEMIGO) or
               (DatosCeldas[fil_vec,col_vec].tipo_esp = ENEMIGO) then begin
               continue;
            end;

            // si es obstculo alguno de ellos, se termina
            if (DatosCeldas[i,j].tipo = OBST) or
               (DatosCeldas[fil_vec,col_vec].tipo = OBST) then begin
               continue;
            end;

            // No se consideran las celdas vecinas fuera del hexgono
            num_vec:= num_vecino_hexa(i,j,fil_vec,col_vec);
            if (num_vec = 0) then begin
               continue;
            end;

            if (hay_obstaculo(DatosCeldas[i,j],DatosCeldas[fil_vec,col_vec]) = TRUE) then begin

               pos.x:=j+1;
               pos.y:=i+1;

               // dependiendo del vecino que suponga un obstculo, se pinta una arista u otra
               case (num_vec) of
                  1: MapaHEX.PintaBordeHex(pos,clBlack,3,clBlack,0,clBlack,0,clBlack,0,clBlack,0,clBlack,0,FALSE);
                  2: MapaHEX.PintaBordeHex(pos,clBlack,0,clBlack,3,clBlack,0,clBlack,0,clBlack,0,clBlack,0,FALSE);
                  3: MapaHEX.PintaBordeHex(pos,clBlack,0,clBlack,0,clBlack,3,clBlack,0,clBlack,0,clBlack,0,FALSE);
                  4: MapaHEX.PintaBordeHex(pos,clBlack,0,clBlack,0,clBlack,0,clBlack,3,clBlack,0,clBlack,0,FALSE);
                  5: MapaHEX.PintaBordeHex(pos,clBlack,0,clBlack,0,clBlack,0,clBlack,0,clBlack,3,clBlack,0,FALSE);
                  6: MapaHEX.PintaBordeHex(pos,clBlack,0,clBlack,0,clBlack,0,clBlack,0,clBlack,0,clBlack,3,FALSE);
               end;

            end;

        end;  // for l
      end;  // for k
    end;  // for j
  end;  // for i

  // una vez dibujado todo, se hace el refresco para dibujar el mapa sin parpadeo
  MapaHEX.Refrescar;

  Showmessage ('Natural Obstacles (Height Difference > ' + intToStr(MAX_DIF_ALTURAS_UNI)
             + ') Marked');

end;

// --------------------------------------------------------------

procedure TfrmMapaCHAC.btnMostrarAreaCAClick(Sender: TObject);
var
  celdau: t_celda;
  e: integer;

begin

   // buscamos la posicin de la unidad (punto origen)
   BuscarOrigenDestinoEnemigo('O',celdau);

   /////////////////////// PRUEBA ////////////////////////////
   /////e:= buscar_enemigo_ca(celdau,CAP_ADQ_UNI,ENEMIGOS,DatosCeldas,NCOLS_MAPA,NFILS_MAPA);
   /////showmessage('Se han encontrado ' + inttostr(e) + ' enemigos');

   // buscamos los enemigos en el mapa
   BuscarEnemigos();

   // se muestra el rea de la unidad
   pintar_area_ca_hex(celdau,CAP_ADQ_UNI,DatosCeldas,NCOLS_MAPA,NFILS_MAPA);

   // se muestran las reas de los enemigos
   for e:=0 to (num_enemigos-1) do begin
      pintar_area_ca_hex(ENEMIGOS[e],CAP_ADQ_ENE,DatosCeldas,NCOLS_MAPA,NFILS_MAPA);
   end;


   //// pintamos la del enemigo 0 de otra forma
   //if (num_enemigos>0) then
   //   pintar_area_ca_dist(ENEMIGOS[0],CAP_ADQ_ENE,DatosCeldas,NCOLS_MAPA,NFILS_MAPA,'EUCLID');


   ShowMessage ('Adquisition Capability Areas Marked:' + #10 +
                'Unit AC = ' + intToStr(CAP_ADQ_UNI) + ' cells' + #10 +
                'Enemy AC = ' + intToStr(CAP_ADQ_ENE) + ' cells');

end;

// --------------------------------------------------------------

procedure TfrmMapaCHAC.btnLimpiarMarcasMapaClick(Sender: TObject);
begin
   LimpiarMarcasMapa();
end;

// --------------------------------------------------------------

procedure TfrmMapaCHAC.btnFPGClick(Sender: TObject);
var
  i: integer;
  fichero_soluciones, fichero_fpg, extension: string;

  bl: string;

  fich_fpg: TextFile;

begin

     bl:= '';
     fichero_fpg:= edFicheroSoluciones.Text + ' (' +edRSel.text + edrs.text + ').txt';

     for i:=1 to 30 do begin

          // se actualiza el nombre del fichero de soluciones
          extension:= ' [' + edRSel.Text + bl + ', s' + IntToStr(i) + ',' +
                      edNumIT.Text + 'it,' + edNumH.Text + 'h,' + edrs.Text + ']'+ '.sol';
          fichero_soluciones:=  edFicheroSoluciones.Text + extension;

          AniadirSolsFPG(fichero_soluciones, FALSE);

     end;

     // escribimos el mnimo en el fichero elegido
     AssignFile(fich_fpg, fichero_fpg);
     Append(fich_fpg);

     for i:=0 to (FPG.num_sols-1) do begin
        Writeln(fich_fpg, FloatToStr(FPG.sols[i].fit_obj1) + #9 + FloatToStr(FPG.sols[i].fit_obj2));
        Flush(fich_fpg);
     end;

     CloseFile(fich_fpg);

     showmessage('El FPG Yast');
end;

// --------------------------------------------------------------

procedure TfrmMapaCHAC.rbtn_dir_SEClick(Sender: TObject);
var
   i,j: integer;
   pos_i, pos_j: integer;

begin

  // damos valores a las variables que definen la zona de ataque
  // sureste <=> frente de ataque

  // reservamos memoria para la nueva plantilla
  Finalize(zona_ataque_enemigo);
  SetLength(zona_ataque_enemigo,NFILS_PLANT_ZA,NCOLS_PLANT_ZA);

  // transformamos la plantilla del frente SUR a frente SURESTE
  for i:=0 to (NFILS_PLANT_ZA-2) do begin
     for j:=0 to (NCOLS_PLANT_ZA-1) do begin

        pos_i:= i+1;
        pos_j:= j;
        zona_ataque_enemigo[pos_i,pos_j]:= zona_ataque_enemigo_S[i,j];

        // volvemos a apuntar la posicin del enemigo en la plantilla
        if (zona_ataque_enemigo[pos_i,pos_j].tipo_esp = ENEMIGO) then begin
           POS_PLANT_ENE_fil:= pos_i;
           POS_PLANT_ENE_col:= pos_j;
        end;

     end;
  end;

end;

// -------------------- FUNCIONES DE EVENTOS --------------------

(*
   Procedimiento que aplica al mapa actual la accin indicada en un evento.
   Recibe como parmetros:
      - evento -> evento a aplicar al mapa actual
*)
procedure HacerEvento(evento: t_evento);
begin

     // tipo de evento
     case (evento.tipo) of
        // insertar enemigo
        INS_ENE:
           DatosCeldas[evento.y_act,evento.x_act].tipo_esp:= ENEMIGO;
        // mover enemigo
        MOV_ENE:
        begin
           DatosCeldas[evento.y_act,evento.x_act].tipo_esp:= NO;
           DatosCeldas[evento.y_sig,evento.x_sig].tipo_esp:= ENEMIGO;
        end;
        // borrar enemigo
        DEL_ENE:
           DatosCeldas[evento.y_act,evento.x_act].tipo_esp:= NO;
        // mover destino
        MOV_DES:
        begin
           DatosCeldas[evento.y_act,evento.x_act].tipo_esp:= NO;
           DatosCeldas[evento.y_sig,evento.x_sig].tipo_esp:= PDESTINO;
        end;
     end;

end;

// --------------------------------------------------------------

(*
   Procedimiento que deshace del mapa actual la accin indicada en un evento.
   Recibe como parmetros:
      - evento -> evento a aplicar al mapa actual
*)
procedure DeshacerEvento(evento: t_evento);
begin

     // tipo de evento
     case (evento.tipo) of
        // insertar enemigo -> borramos el enemigo
        INS_ENE:
           DatosCeldas[evento.y_act,evento.x_act].tipo_esp:= NO;
        // mover enemigo -> lo movemos hacia la posicin anterior
        MOV_ENE:
        begin
           DatosCeldas[evento.y_act,evento.x_act].tipo_esp:= ENEMIGO;
           DatosCeldas[evento.y_sig,evento.x_sig].tipo_esp:= NO;
        end;
        // borrar enemigo -> se vuelve a insertar
        DEL_ENE:
           DatosCeldas[evento.y_act,evento.x_act].tipo_esp:= ENEMIGO;
        // mover destino -> se mueve a la posicin anterior
        MOV_DES:
        begin
           DatosCeldas[evento.y_act,evento.x_act].tipo_esp:= PDESTINO;
           DatosCeldas[evento.y_sig,evento.x_sig].tipo_esp:= NO;
        end;
     end;

end;

// --------------------------------------------------------------

// Cargamos el fichero de eventos asociado al mapa actual
procedure TfrmMapaCHAC.btnCargarEventosClick(Sender: TObject);
begin

  dlgCargarEventos.InitialDir:= GetCurrentDir;

  // Se muestra el Dilogo para Abrir el Fichero del Mapa
  if dlgCargarEventos.Execute then begin

     eventos_cargados:= FALSE;
     edNumEvento.Text:= '';

     // se cargan las soluciones del fichero en la variable
     CargarEventos(dlgCargarEventos.FileName);

     eventos_cargados:= TRUE;

     // nos situamos en el primer evento
     edNumEvento.Text:= 'I';
     ind_evento:= -1;

     showmessage('Eventos leidos correctamente');

     // habilitamos los botones de avance/retroceso de eventos
     btnDInicio.Enabled:= TRUE;
     btnDAvanzar.Enabled:= TRUE;
     btnDRetroceder.Enabled:= TRUE;
     btnDFin.Enabled:= TRUE;

  end;

end;

// --------------------------------------------------------------

procedure TfrmMapaCHAC.btnDInicioClick(Sender: TObject);
begin

   // volvemos al mapa inicial (lo cargamos de nuevo)

   // volvemos al evento inicial
   edNumEvento.Text:= 'I';
   ind_evento:= -1;

   edITEvento.Text:='IT';
   edAccionEvento.Text:= 'ACCIN';
   edXactEvento.Text:='X';
   edYactEvento.Text:='X';
   lblAccionEvento.Caption:= '';
   edXsigEvento.Text:='X';
   edYsigEvento.Text:='X';

   CargarMapa(MapaActual);

   // *** actualizar las soluciones??? ***

end;

// --------------------------------------------------------------

procedure TfrmMapaCHAC.btnDRetrocederClick(Sender: TObject);
begin

   // volvemos al evento anterior

   // si es el primero no se puede volver
   if (ind_evento < 0) then begin
     showmessage('No hay eventos anteriores');
     exit;
   end;

   // si es el primero, volvemos al mapa inicial
   if (ind_evento = 0) then begin
      edNumEvento.Text:= 'I';
      ind_evento:= -1;

      edITEvento.Text:='IT';
      edAccionEvento.Text:= 'ACCIN';
      edXactEvento.Text:='X';
      edYactEvento.Text:='X';
      lblAccionEvento.Caption:= '';
      edXsigEvento.Text:='X';
      edYsigEvento.Text:='X';

      CargarMapa(MapaActual);
      exit;
   end;

   // deshacemos el ltimo evento
   DeshacerEvento(EVENTOS[ind_evento]);

   // pasamos al evento anterior
   ind_evento:= ind_evento - 1;

   if (EVENTOS[ind_evento].it = -1) then begin
      showmessage ('El Evento tiene asociada una accin incorrecta');
      exit;
   end;

   // hacemos el evento anterior
   HacerEvento(EVENTOS[ind_evento]);

   // actualizamos la informacin del evento
   if (ind_evento = -1) then
     edNumEvento.Text:='I'
   else
     edNumEvento.Text:=IntToStr(ind_evento);

   edITEvento.Text:= IntToStr(EVENTOS[ind_evento].it);

   if (EVENTOS[ind_evento].tipo = INS_ENE) then begin
      edAccionEvento.Text:= 'INS_ENE';
      lblAccionEvento.Caption:= '+';
   end
   else if (EVENTOS[ind_evento].tipo = DEL_ENE) then begin
      edAccionEvento.Text:= 'DEL_ENE';
      lblAccionEvento.Caption:= '-';
   end
   else if (EVENTOS[ind_evento].tipo = MOV_ENE) then begin
      edAccionEvento.Text:= 'MOV_ENE';
      lblAccionEvento.Caption:= '>';
   end
   else if (EVENTOS[ind_evento].tipo = MOV_DES) then begin
      edAccionEvento.Text:= 'MOV_DES';
      lblAccionEvento.Caption:= '>';
   end;

   edXactEvento.Text:= IntToStr(EVENTOS[ind_evento].x_act);
   edYactEvento.Text:= IntToStr(EVENTOS[ind_evento].y_act);
   edXsigEvento.Text:= IntToStr(EVENTOS[ind_evento].x_sig);
   edYsigEvento.Text:= IntToStr(EVENTOS[ind_evento].y_sig);

   // redibujamos el mapa
   LimpiarMarcasMapa();

end;

// --------------------------------------------------------------

procedure TfrmMapaCHAC.btnDAvanzarClick(Sender: TObject);
begin
   // volvemos al evento anterior

   // si es el ltimo, no se puede avanzar
   if (ind_evento = (num_eventos-1)) then begin
     showmessage('No hay eventos posteriores');
     exit;
   end;

   // pasamos al evento siguiente
   ind_evento:= ind_evento + 1;

   if (EVENTOS[ind_evento].it = -1) then begin
      showmessage ('El Evento tiene asociada una accin incorrecta');
      exit;
   end;

   // hacemos el nuevo evento
   HacerEvento(EVENTOS[ind_evento]);

   // actualizamos la informacin del evento
   if (ind_evento = (num_eventos-1)) then
     edNumEvento.Text:='F'
   else
     edNumEvento.Text:=IntToStr(ind_evento);

   edITEvento.Text:= IntToStr(EVENTOS[ind_evento].it);

   if (EVENTOS[ind_evento].tipo = INS_ENE) then begin
      edAccionEvento.Text:= 'INS_ENE';
      lblAccionEvento.Caption:= '+';
   end
   else if (EVENTOS[ind_evento].tipo = DEL_ENE) then begin
      edAccionEvento.Text:= 'DEL_ENE';
      lblAccionEvento.Caption:= '-';
   end
   else if (EVENTOS[ind_evento].tipo = MOV_ENE) then begin
      edAccionEvento.Text:= 'MOV_ENE';
      lblAccionEvento.Caption:= '>';
   end
   else if (EVENTOS[ind_evento].tipo = MOV_DES) then begin
      edAccionEvento.Text:= 'MOV_DES';
      lblAccionEvento.Caption:= '>';
   end;

   edXactEvento.Text:= IntToStr(EVENTOS[ind_evento].x_act);
   edYactEvento.Text:= IntToStr(EVENTOS[ind_evento].y_act);
   edXsigEvento.Text:= IntToStr(EVENTOS[ind_evento].x_sig);
   edYsigEvento.Text:= IntToStr(EVENTOS[ind_evento].y_sig);

   // redibujamos el mapa
   LimpiarMarcasMapa();

end;

// --------------------------------------------------------------

procedure TfrmMapaCHAC.btnDFinClick(Sender: TObject);
var
  i: integer;

begin
   // aplicamos todos los eventos hasta el final

   // si es el ltimo, no se hace nada
   if (ind_evento = (num_eventos-1)) then begin
     showmessage('Ya estamos en el mapa final');
     exit;
   end;

   // recorremos los eventos restantes y los hacemos
   for i:=(ind_evento+1) to (num_eventos-1) do begin
      if (EVENTOS[ind_evento].it = -1) then begin
         showmessage ('El Evento tiene asociada una accin incorrecta');
         exit;
      end;

      HacerEvento(EVENTOS[i]);
   end;

   // situamos el ndice en el ltimo evento
   ind_evento:= num_eventos - 1;

   // mostramos la etiqueta 'Final'
   edNumEvento.Text:='F';

   edITEvento.Text:= IntToStr(EVENTOS[ind_evento].it);

   // mostramos el tipo de evento
   if (EVENTOS[ind_evento].tipo = INS_ENE) then begin
      edAccionEvento.Text:= 'INS_ENE';
      lblAccionEvento.Caption:= '+';
   end
   else if (EVENTOS[ind_evento].tipo = DEL_ENE) then begin
      edAccionEvento.Text:= 'DEL_ENE';
      lblAccionEvento.Caption:= '-';
   end
   else if (EVENTOS[ind_evento].tipo = MOV_ENE) then begin
      edAccionEvento.Text:= 'MOV_ENE';
      lblAccionEvento.Caption:= '>';
   end
   else if (EVENTOS[ind_evento].tipo = MOV_DES) then begin
      edAccionEvento.Text:= 'MOV_DES';
      lblAccionEvento.Caption:= '>';
   end;

   edXactEvento.Text:= IntToStr(EVENTOS[ind_evento].x_act);
   edYactEvento.Text:= IntToStr(EVENTOS[ind_evento].y_act);
   edXsigEvento.Text:= IntToStr(EVENTOS[ind_evento].x_sig);
   edYsigEvento.Text:= IntToStr(EVENTOS[ind_evento].y_sig);

   // redibujamos el mapa
   LimpiarMarcasMapa();

end;

End.



(*

NOTAS:

- las celdas se acceden en la matriz como [fila,columna].
  sus coordenadas correspondientes seran x=columna, y=fila

- al guardar la altura, recordar que est invertida en las celdas normales y de bosque:
   alt := alt * -1

  y que en las celdas de agua:
    -3 <-> 0
    -2 <-> -1
    -1 <-> -2
     0 <-> -3

     alt:= (alt + 3) * -1

- el dao infligido va de 1 a 4 si hay un impacto de arma en la celda:

  1 -> 20%
  2 -> 40%
  3 -> 60%
  4 -> 80%

*)

